#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <math.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "file_man.h"

void
makeWheel(char whichHead)
{
	unsigned int AT, RW, QR;
	int x, y, mask=0x01;
	float  alfa;
        char  i, max, txt[30];
	const int X=350, Y=350, R=310, r=225;
        const float pi = 3.1415;
	const char buttonSize = 80, switchSize = 50; 
	GtkWidget *mainBox, *fixed, *headPix, *tshirtPix, *headNrLabel, *on_offBox, *onPix, *offPix;  

	mainBox = lookup_widget(GTK_WIDGET(mainWindow),"mainBox");

      	alfa = (float) 2 * pi / (mach_size-1);
    	

	if (whichHead >= 0) {i = whichHead; max = whichHead+1;}
	else {i = 0; max = mach_size-2;}

       for (;i<max;i++)
	{

		x = X - buttonSize/2 + R * sin( (float)(i+1)* alfa ) ;
		y = Y - buttonSize/2 + R * cos( (float)(i+1)* alfa ) ;
		
		AT = ATflash_f & mask << i;
		RW = RWflash_f & mask << i;
/* 		QR = QRflash_f & mask << i; */

  		fixed = gtk_fixed_new ();
  		gtk_widget_ref (fixed);
		sprintf(txt,"headBox%d",i+1);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, fixed,
                            (GtkDestroyNotify) gtk_widget_unref);

		gtk_widget_show (fixed);
  		gtk_fixed_put (GTK_FIXED (mainBox), fixed, x, y);
  		gtk_widget_set_uposition (fixed, x, y);
  		gtk_widget_set_usize (fixed, buttonSize, buttonSize);

		if (RW != 0) headPix = create_pixmap (mainWindow, "pix/head_RW.xpm", FALSE);
		else if (AT != 0) headPix = create_pixmap (mainWindow, "pix/head_AT.xpm", FALSE);
/* 		else if (QR != 0) headPix = create_pixmap (mainWindow, "pix/head_QR.xpm", FALSE); */
		else headPix = create_pixmap (mainWindow, "pix/head.xpm", FALSE);
  		gtk_widget_ref (headPix);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), "headPix", headPix,
                            (GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (headPix);
  		gtk_fixed_put (GTK_FIXED (fixed), headPix, 0, 0);
  		gtk_widget_set_uposition (headPix, 0, 0);
  		gtk_widget_set_usize (headPix, buttonSize, buttonSize);

		if (RW != 0) tshirtPix = create_pixmap (mainWindow, "pix/tshirt_RW.xpm", FALSE);
		else if (AT != 0) tshirtPix = create_pixmap (mainWindow, "pix/tshirt_AT.xpm", FALSE);
/* 		else if (QR != 0) tshirtPix = create_pixmap (mainWindow, "pix/tshirt_QR.xpm", FALSE); */
		else tshirtPix = create_pixmap (mainWindow, "pix/tshirt.xpm", FALSE);
		gtk_widget_ref (tshirtPix);
		sprintf(txt,"h%.2dtshirtPix",i+1);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, tshirtPix,
                            (GtkDestroyNotify) gtk_widget_unref);
  		if ((tshirt_f & mask << i) == 0) gtk_widget_hide (tshirtPix);
		else gtk_widget_show (tshirtPix);
  		gtk_fixed_put (GTK_FIXED (fixed), tshirtPix, 0, 0);
  		gtk_widget_set_uposition (tshirtPix, 0, 0);
  		gtk_widget_set_usize (tshirtPix, buttonSize, buttonSize);

        	sprintf(txt,"%d",i+1);
		if (AT != 0) sprintf (txt,"%d<-%d",machine_param.ATflash[i].socket_f,i+1);
		if (RW != 0) sprintf (txt,"%d<-%d",machine_param.RWflash[i].socket_f,i+1);
		headNrLabel = gtk_label_new (txt);

  		gtk_widget_ref (headNrLabel);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), "headLabel", headNrLabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (headNrLabel);
  		gtk_fixed_put (GTK_FIXED (fixed), headNrLabel, 0, buttonSize-25);
  		gtk_widget_set_uposition (headNrLabel, 0, buttonSize-25);
  		gtk_widget_set_usize (headNrLabel, buttonSize, 25);
		
		if (AT != 0) 
		{
        	sprintf(txt,"AT%dLabel",i+1);
		headNrLabel = gtk_label_new ("000F");

  		gtk_widget_ref (headNrLabel);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, headNrLabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (headNrLabel);
  		gtk_fixed_put (GTK_FIXED (fixed), headNrLabel, 4, buttonSize-61);
  		gtk_widget_set_uposition (headNrLabel, 4, buttonSize-61);
  		gtk_widget_set_usize (headNrLabel, 60, 20);		
		}

  		gtk_signal_connect (GTK_OBJECT (fixed), "button_press_event",
                      GTK_SIGNAL_FUNC (on_head_button_press_event),
                      i);


		x = X - switchSize/2 + r * sin( (float)(i+1)* alfa );
		y = Y - switchSize/2 + r * cos( (float)(i+1)* alfa );

  		on_offBox = gtk_fixed_new ();
  		gtk_widget_ref (on_offBox);
		sprintf(txt,"on_offBox%d",i+1);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, on_offBox,
                            (GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_show (on_offBox);
  		gtk_fixed_put (GTK_FIXED (mainBox), on_offBox, x, y);
  		gtk_widget_set_uposition (on_offBox, x, y);
  		gtk_widget_set_usize (on_offBox, switchSize, switchSize);
		
		onPix = create_pixmap (mainWindow, "pix/head_on.xpm", FALSE);
  		gtk_widget_ref (onPix);
  		sprintf(txt,"h%.2donPix",i+1);
		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, onPix,
                            (GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (onPix);
  		gtk_fixed_put (GTK_FIXED (on_offBox), onPix, 0, 0);
  		gtk_widget_set_uposition (onPix, 0, 0);
  		gtk_widget_set_usize (onPix, switchSize, switchSize);

		offPix = create_pixmap (mainWindow, "pix/head_off.xpm", FALSE);
  		gtk_widget_ref (offPix);
		sprintf(txt,"h%.2doffPix",i+1);
  		gtk_object_set_data_full (GTK_OBJECT (mainWindow), txt, offPix,
                            (GtkDestroyNotify) gtk_widget_unref);
  		if ((en_head_f & mask << i) != 0) gtk_widget_hide (offPix);
		else gtk_widget_show (offPix);
  		gtk_fixed_put (GTK_FIXED (on_offBox), offPix, 0, 0);
  		gtk_widget_set_uposition (offPix, 0, 0);
  		gtk_widget_set_usize (offPix, switchSize, switchSize);

  		gtk_signal_connect (GTK_OBJECT (on_offBox), "button_press_event",
                      GTK_SIGNAL_FUNC (on_off_button_press_event),
                      i);
	}	
}

void
destroyWheel()
{
       char i, txt[30];
       GtkWidget *box;
       
       for (i=0;i<(mach_size-2);i++)
       {
		sprintf(txt,"headBox%d",i+1);
		box = lookup_widget(GTK_WIDGET(mainWindow),txt);	       
		gtk_widget_destroy(box);
		sprintf(txt,"on_offBox%d",i+1);
		box = lookup_widget(GTK_WIDGET(mainWindow),txt);	       
		gtk_widget_destroy(box);		
       }
}


void
rebuildHead(char whichHead)
{
	char txt[30];
	
	if (whichHead >= 0) 
	{
		sprintf(txt,"headBox%d",whichHead+1);
		gtk_widget_destroy(lookup_widget(GTK_WIDGET(mainWindow),txt));
		sprintf(txt,"on_offBox%d",whichHead+1);
		gtk_widget_destroy(lookup_widget(GTK_WIDGET(mainWindow),txt));
	
		makeWheel(whichHead);
	}
}


void refreshStatus()
{
if (mode_f == 0) gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"modeStatus"), _("MODE: manual"));
else gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"modeStatus"), _("MODE: auto"));

if ( home_f == 0) gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"homeStatus"), _("HOME: no"));
else gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"homeStatus"), _("HOME: yes"));

if (idx_dir_f == 0) gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"directionStatus"), _("DIR: cw"));
else gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"directionStatus"), _("DIR: ccw"));

if (idx_en_f == 0) gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"indexerStatus"), _("INDEX: disable"));
else gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"indexerStatus"), _("INDEX: enable"));

if (lift_en_f == 0) gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"liftStatus"), _("LIFT: disable"));
else gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"liftStatus"), _("LIFT: enable"));
}


void
on_head_button_press_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        char         data)
{
	GtkWidget *ikona;
	char txt[30];
	unsigned int mask=0x01;


        sprintf(txt,"h%.2dtshirtPix",data+1);
	ikona = lookup_widget(GTK_WIDGET(widget),txt);
	mask <<= data;
	tshirt_f ^= mask;
        if ((tshirt_f & mask) != 0) gtk_widget_show(ikona);
        else gtk_widget_hide(ikona);
}

void
on_off_button_press_event             (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        char         data)
{
	GtkWidget *ikona;
	char txt[30];
	unsigned int mask=0x01;


        sprintf(txt,"h%.2doffPix",data+1);
	ikona = lookup_widget(GTK_WIDGET(widget),txt);
	mask <<= data;
	en_head_f ^= mask;
        if ((en_head_f & mask) == 0) gtk_widget_show(ikona);
        else gtk_widget_hide(ikona);
}

void
on_setupBox_button_press_event         (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	//machine_param.mach_size = mach_size - 6; // !!! 
  	machine_paramTmp = machine_param;
	showSetup();
}

void
on_setupCloseButton_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
        char txt[30];	
	GtkWidget *dwellLabel;
	
	if (saveParams  (&machine_param, "par/default.par") & saveParams  (&machine_param, "backup/default.par")) printMsg
	(_("\n>defaults OK"));
	else  printMsg (_("\n>defaults save filed"));

	refreshLevel_f=0x00;	
	gtk_widget_destroy(setupWindow);
	
	dwellLabel = lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel");
	paramNr = dwell_time;
	paramData(&machine_param);
	paramValuePrint(&txt);
	gtk_label_set_text (dwellLabel, txt);
}


void
on_setupApplyButton_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
char i;

	if (refreshLevel_f == 0x01)
	{
		head2soc(4); //rebuild flash heads
		if ((show_hide_f & 0x01) != 0)	gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));
		else  gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));
		if ((show_hide_f & 0x02) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
		else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
		if ((show_hide_f & 0x04) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));
		else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));
		if ((show_hide_f & 0x08) != 0) gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
		else gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));	
		refreshLevel_f=0x00;	
	}
	machine_param = machine_paramTmp;	
	
	if ((mach_size != machine_param.mach_size+6))
	{
		destroyWheel();
		mach_size = machine_param.mach_size+6; // !!! nesesery
		makeWheel(-1);	
	}

			if ((show_hide_f & 0x01) != 0)	gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));
			else  gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));
			if ((show_hide_f & 0x02) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
			else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
			if ((show_hide_f & 0x04) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));
			else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));
			if ((show_hide_f & 0x08) != 0) gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
			else gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
				
	refreshWheel();
}


void
showSetup ()
{
	GtkWidget *box;
	GtkWidget *file1Label, *file2Label, *file3Label, *file4Label; 
	char txt[30];
	
	
	setupWindow = create_setupWindow ();
	gtk_widget_set_name( setupWindow, "setup" );

/********************************************************************************************************

makeParButton (arg1,arg2,arg3,arg4):
	arg1 => paramNr=... 	- enum parameter name
	arg2 => 1 or 3 		- selects column 
	arg3 => 1 ... 8		- selects row
	arg4 => "..."		- setup notebook's box pointer

makeCtrlButton 	(arg1,arg2,arg3,arg4,arg5);
	arg1 => int		- button number -> look at controlButtonPressed function in global.c
	arg2 => 1 ... 4 	- selects column 
	arg3 => 1 ... 8		- selects row
	arg4 => "..."		- setup notebook's box pointer
	arg5 => 0 or 1		- button type
	arg6 => 0, 1, ..	- authoryzation level	
*********************************************************************************************************/

  box = lookup_widget (GTK_WIDGET(setupWindow),"mainSetupBox");

/*******	MAIN PARAMETERS			*******/

	makeParButton (paramNr=dwell_time,1,2,box);	makeParButton (paramNr=off_contact,2,2,box);
	makeParButton (paramNr=head_print_delay,1,3,box);makeParButton (paramNr=head_flood_delay,2,3,box); 	
	makeParButton (paramNr=machine_size,2,4,box);

	makeCtrlButton (buttonNr=M_LIFT_DOWN,1,4,box,1,1);

  	makeCtrlButton 	(buttonNr=RESET_COUNTER,3,5,box,0,1);
	makeCtrlButton 	(buttonNr=HIDE_COUNTERS,4,5,box,0,1);	
   	makeCtrlButton 	(buttonNr=PANEL_ON_OFF,4,6,box,0,1);  	
	makeCtrlButton 	(buttonNr=HIDE_STATUS,4,7,box,0,1);
	
	makeCtrlButton 	(buttonNr=TEST_PRINT,1,5,box,0,1);
  	makeCtrlButton 	(buttonNr=TABLE_UP_DOWN,2,5,box,0,1);

	makeCtrlButton 	(buttonNr=MODE,1,6,box,0,1);

  	makeCtrlButton 	(buttonNr=RESET,1,8,box,0,0);
  	makeCtrlButton 	(buttonNr=HOME,2,8,box,0,0);	
	



  box = lookup_widget (GTK_WIDGET(setupWindow),"headSetupBox");

/*******	HEAD PARAMETERS			*******/	
	makeParButton (paramNr=head_print_vel,1,1,box);		makeParButton (paramNr=head_flood_vel,2,1,box);		
	makeParButton (paramNr=head_front_pos,1,2,box);		makeParButton (paramNr=head_rear_pos,2,2,box);
	makeParButton (paramNr=head_jog_vel,1,3,box);		makeParButton (paramNr=head_home_vel,2,3,box);		
	makeParButton (paramNr=head_home_offset,1,4,box);
	makeParButton (paramNr=head_m_print,1,5,box);		// on 3,7 select head button

/*******	HEAD BUTTONS			*******/
  	makeCtrlButton 	(buttonNr=HEAD_HOME,1,8,box,0,1);
    	makeCtrlButton 	(buttonNr=HEAD_TEST_PRINT,2,8,box,0,1);
	makeCtrlButton 	(buttonNr=HEAD_ENABLE_DISABLE,3,8,box,0,1);


  box = lookup_widget (GTK_WIDGET(setupWindow),"flashSetupBox");

/*******	FLASH  SETUP			*******/
  	makeCtrlButton 	(buttonNr=AT_FLASH_SET_REMOVE,1,8,box,0,1);
    	makeCtrlButton 	(buttonNr=RW_FLASH_SET_REMOVE,2,8,box,0,1);
/* 	makeCtrlButton 	(buttonNr=QR_FLASH_SET_REMOVE,3,8,box,0,1); */


  box = lookup_widget (GTK_WIDGET(setupWindow),"flashATSetupBox");
	
/*******	FLASH AT PARAMETERS		*******/
	makeParButton (paramNr=flash_AT_cure_time,1,1,box);	makeParButton (paramNr=flash_AT_temp,2,1,box);
	makeParButton (paramNr=flash_AT_stby_time,1,2,box);	makeParButton (paramNr=flash_AT_stby_power,2,2,box);	
	makeParButton (paramNr=flash_AT_warm_up_time,1,3,box);	

/*******	FLASH AT BUTTONS		*******/
	makeCtrlButton 	(buttonNr=FLASH_AT_SENSOR_TYPE,3,3,box,1,1);
	makeCtrlButton 	(buttonNr=FLASH_AT_PREHEAT_F,1,4,box,1,1);
	makeCtrlButton 	(buttonNr=FLASH_AT_SOCKET_NR,3,4,box,1,1);
	

/*   box = lookup_widget (GTK_WIDGET(setupWindow),"flashQRSetupBox"); */

/*******	FLASH QR PARAMETERS		*******/
	
/* 	makeParButton (paramNr=flash_QR_scan_dist,1,1,box);	makeParButton (paramNr=flash_QR_scan_vel,2,1,box);
	makeParButton (paramNr=flash_QR_appr_dist,1,2,box);	makeParButton (paramNr=flash_QR_appr_vel,2,2,box);
	makeParButton (paramNr=flash_QR_nr_of_scans,1,3,box); */
	
/*******	FLASH QR BUTTONS		*******/	
/* 	makeCtrlButton 	(buttonNr=FLASH_QR_PREHEAT_ON_OFF,3,3,box,1,1);
	makeCtrlButton 	(buttonNr=FLASH_QR_HOME,1,5,box,0,1); */


  box = lookup_widget (GTK_WIDGET(setupWindow),"flashRWSetupBox");

/*******	FLASH RW PARAMETERS		*******/	
	/* makeParButton (paramNr=flash_RW_preheat_time,2,1,box); */	makeParButton (paramNr=flash_RW_cure_time,1,1,box);

/*******	FLASH RW BUTTONS		*******/	
	/* makeCtrlButton 	(buttonNr=FLASH_RW_PREHEAT_ON_OFF,1,2,box,1,1); */		
	makeCtrlButton 	(buttonNr=FLASH_RW_SOCKET_NR,3,1,box,1,1);

  box = lookup_widget (GTK_WIDGET(setupWindow),"indexSetupBox");
			
/*******	INDEX PARAMETERS		*******/	
	makeParButton (paramNr=index_home_offset,1,1,box);	makeParButton (paramNr=index_dist,2,1,box);
	makeParButton (paramNr=index_home_vel,1,2,box);		makeParButton (paramNr=index_home_acc,2,2,box);
	makeParButton (paramNr=index_vel,1,3,box);		makeParButton (paramNr=index_acc,2,3,box);
	makeParButton (paramNr=index_ret_vel,1,4,box);		makeParButton (paramNr=index_ret_acc,2,4,box);
	makeParButton (paramNr=index_half_vel,1,5,box);		makeParButton (paramNr=index_half_acc,2,5,box);	

/*******	INDEX BUTTONS		*******/	
	makeCtrlButton 	(buttonNr=INDEX_ENABLE_DISABLE,1,7,box,0,1);	
	makeCtrlButton 	(buttonNr=INDEX_CHANGE_DIRECTION,2,7,box,0,1);
	makeCtrlButton 	(buttonNr=INDEX_LEFT,3,7,box,0,1);	
	makeCtrlButton 	(buttonNr=INDEX_RIGHT,4,7,box,0,1);	
	makeCtrlButton 	(buttonNr=INDEX_HOME,1,8,box,0,1);	
	makeCtrlButton 	(buttonNr=HALF_INDEX_LEFT,3,8,box,0,1);	
	makeCtrlButton 	(buttonNr=HALF_INDEX_RIGHT,4,8,box,0,1);	


  box = lookup_widget (GTK_WIDGET(setupWindow),"liftSetupBox");
			
/*******	LIFT PARAMETERS		*******/	
	makeParButton (paramNr=lift_home_offset,1,1,box);	makeParButton (paramNr=lift_dist,2,1,box);
	makeParButton (paramNr=lift_home_vel,1,2,box);		makeParButton (paramNr=lift_home_acc,2,2,box);
	makeParButton (paramNr=lift_vel,1,3,box);		makeParButton (paramNr=lift_acc,2,3,box);


/*******	LIFT BUTTONS		*******/	
	makeCtrlButton 	(buttonNr=LIFT_ENABLE_DISABLE,1,7,box,0,1);	
	makeCtrlButton 	(buttonNr=LIFT_UP,3,7,box,0,1);	
	makeCtrlButton 	(buttonNr=LIFT_DOWN,4,7,box,0,1);	
	makeCtrlButton 	(buttonNr=LIFT_HOME,1,8,box,0,1);	


  box = lookup_widget (GTK_WIDGET(setupWindow),"saveRecallSetupBox");

/*******	SAVE RECALL LABELS	*******/
  file1Label = gtk_label_new ("1");
  gtk_widget_ref (file1Label);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), "file1Label", file1Label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file1Label);
  gtk_fixed_put (GTK_FIXED (box), file1Label, 200, 150);
  gtk_widget_set_usize (file1Label, 200, 50);
  
  file2Label = gtk_label_new ("2");
  gtk_widget_ref (file2Label);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), "file2Label", file2Label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file2Label);
  gtk_fixed_put (GTK_FIXED (box), file2Label, 200, 200);
  gtk_widget_set_usize (file2Label, 200, 50);
  
  file3Label = gtk_label_new ("3");
  gtk_widget_ref (file3Label);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), "file3Label", file3Label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file3Label);
  gtk_fixed_put (GTK_FIXED (box), file3Label, 200, 350);
  gtk_widget_set_usize (file3Label, 200, 50);
  
  file4Label = gtk_label_new ("4");
  gtk_widget_ref (file4Label);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), "file4Label", file4Label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (file4Label);
  gtk_fixed_put (GTK_FIXED (box), file4Label, 200, 400);
  gtk_widget_set_usize (file4Label, 200, 50);    
  
/*******	SAVE RECALL BUTTONS	*******/
	makeCtrlButton 	(buttonNr=SAVE_JOB,1,8,box,0,1);
	makeCtrlButton 	(buttonNr=RECALL_JOB,2,8,box,0,1);
	makeCtrlButton  (buttonNr=EDIT_JOB,4,8,box,0,1);

//select head label refresh
	if (allHeads == 1) sprintf (txt,"all heads");
	else sprintf (txt,"head nr %d", setupHeadNr+1);
	gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"selHead_HeadLabel"), txt);
	gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"selHead_FlashLabel"), txt);
	
	refreshHead ();
	refreshFlash ();
	refreshJob ();
	head2soc (01);
	
  	gtk_widget_show (setupWindow);
	
}



void
makeParButton 	(	int parNr,
			char posX,
			char posY,
			GtkWidget *box)
{
	GtkWidget *frame, *button, *label;
	unsigned int x,y;
	char txt[30]="";
	
	paramData(&machine_paramTmp);
	
	x = posX*30 + (posX-1)*250;
	y = posY*10 + (posY-1)*65;

	frame = gtk_frame_new (parameter.name);
  	gtk_widget_ref (frame);
  	gtk_object_set_data_full (GTK_OBJECT (setupWindow), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
 	
	gtk_fixed_put (GTK_FIXED (box), frame, x, y);
	gtk_widget_set_uposition (frame, x, y);

	gtk_widget_set_usize (frame, 250, 65);
  	
	button = gtk_button_new ();
	gtk_widget_ref (button);
  	gtk_object_set_data_full (GTK_OBJECT (setupWindow), "button", button,
                            (GtkDestroyNotify) gtk_widget_unref);
  	gtk_container_add (GTK_CONTAINER (frame), button);
	gtk_button_set_relief (GTK_BUTTON (button), GTK_RELIEF_HALF);

	paramValuePrint (&txt);
		
  	label = gtk_label_new (txt);
	switch (parameter.aut_level)
	{
		case 0: gtk_widget_set_name (frame,"setupFrame0");
			gtk_widget_set_name (button,"setupButton0");break;
		case 1: gtk_widget_set_name (frame,"setupFrame1");
			gtk_widget_set_name (button,"setupButton1");break;
		case 2: gtk_widget_set_name (frame,"setupFrame2");
			gtk_widget_set_name (button,"setupButton2");break;
	}
  	gtk_widget_ref (label);
  	gtk_object_set_data_full (GTK_OBJECT (setupWindow), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  	
  	gtk_container_add (GTK_CONTAINER (button), label);

	paramLabel[parNr] = label;
	
	if (parameter.aut_level <= autorizationLevel)
	{	
		gtk_widget_show (frame);
		gtk_widget_show (button);
		gtk_widget_show (label);
	}

	gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (startLog),
                      parNr);
}


void makeCtrlButton (int buttonNr, char posX, char posY, GtkWidget *box, char type, char autLev)
{
  GtkWidget *button, *label;
  char txt[30];
  unsigned int x,y;
  
  if (type == 0) {
  	x = posX*30 + (posX-1)*110;
	y = posY*10 + (posY-1)*65;  
  } else {
    	x = posX*30 + (posX-1)*110;
	y = posY*10 + (posY-1)*65 + 15;  
  }
	sprintf (txt,"ctrlButton%d",buttonNr);  
  
  button =  gtk_button_new ();
  gtk_widget_ref (button);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), txt, button,
                            (GtkDestroyNotify) gtk_widget_unref);
  
  if (autorizationLevel >= autLev) gtk_widget_show (button);
  
  gtk_fixed_put (GTK_FIXED (box), button, x, y);
  gtk_widget_set_uposition (button, x, y);
 
   if (type == 0) {
	gtk_widget_set_name (button,"setupButton0");
	  gtk_widget_set_usize (button, 110, 65);
  } else {
  	gtk_widget_set_name (button,"setupButton1");
	  gtk_widget_set_usize (button, 250, 50);
  } 

  
  	sprintf (txt,"ctrlLabel%d",buttonNr);

  label = gtk_label_new ("");
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (setupWindow), txt, label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (button), label);
  
  setCtrlButtonName(buttonNr);
  
  gtk_signal_connect (GTK_OBJECT (button), "clicked",
                      GTK_SIGNAL_FUNC (controlButtonPressed),
                      buttonNr);
}


void setCtrlButtonName(int buttonNr)
{
	GtkWidget *label;
	char txt[30];
	unsigned int mask=0x01;
	
	mask <<= setupHeadNr;
	sprintf (txt,"ctrlLabel%d",buttonNr);


	switch (buttonNr)
	{
		case HIDE_COUNTERS: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((show_hide_f & 0x04) == 0) sprintf (txt,_("COUNTERS\nON"));	
			else sprintf (txt,_("COUNTERS\nOFF"));	
			gtk_label_set_text (label, txt);		
		break;			
		case RESET_COUNTER: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("RESET\nCOUNTER"));	
			gtk_label_set_text (label, txt);		
		break;
/* 		case FREE_WHEEL: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("FREE\nWHEEL"));	
			gtk_label_set_text (label, txt); */		
		break;
		case TABLE_UP_DOWN:
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("TABLE\nUP/DOWN"));	
			gtk_label_set_text (label, txt);		
		break;
		case TEST_PRINT:
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("TEST\nPRINT"));	
			gtk_label_set_text (label, txt);		
		break;
		case RESET: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("RESET"));	
			gtk_label_set_text (label, txt);		
		break;
		case HOME: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("HOME"));	
			gtk_label_set_text (label, txt);		
		break;
		case PANEL_ON_OFF: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((show_hide_f & 0x01) == 0) sprintf (txt,_("CTRL PANEL\nOFF"));	
			else sprintf (txt,_("CTRL PANEL\nON"));	
			gtk_label_set_text (label, txt);		
		break;	
		case HIDE_STATUS: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((show_hide_f & 0x02) == 0) sprintf (txt,_("STATUS\nON"));	
			else sprintf (txt,_("STATUS\nOFF"));	
			gtk_label_set_text (label, txt);		
		break;		
		case MODE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((mode_f & 0x01) == 0) sprintf (txt,_("MANUAL\nMODE"));	
			else sprintf (txt,_("AUTO\nMODE"));	
			gtk_label_set_text (label, txt);		
		break;				
		case M_LIFT_DOWN: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if (machine_paramTmp.m_lift_down == 0) sprintf (txt,_("MultiPrint\nlift down: OFF"));	
			else sprintf (txt,_("MultiPrint\nlift down: ON"));	
			gtk_label_set_text (label, txt);		
		break;				

/*******	HEAD BUTTONS			*******/
		case HEAD_ENABLE_DISABLE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((en_head_f & mask) == 0) sprintf (txt,_("DISABLE"));	
			else sprintf (txt,_("ENABLE"));				
			gtk_label_set_text (label, txt);			
		break;
		case HEAD_TEST_PRINT: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("TEST\nPRINT"));	
			gtk_label_set_text (label, txt);		
		break;
		case HEAD_HOME: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("HEAD\nHOME"));	
			gtk_label_set_text (label, txt);		
		break;
		 
/*******	FLASH setupWindowS			*******/
		case AT_FLASH_SET_REMOVE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((ATflash_f & mask) == 0) sprintf (txt,_("SET\nAT FLASH"));	
			else sprintf (txt,_("REMOVE\nAT FLASH"));		
			gtk_label_set_text (label, txt);		
		break;
		case RW_FLASH_SET_REMOVE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((RWflash_f & mask) == 0) sprintf (txt,_("SET\nRW FLASH"));	
			else sprintf (txt,_("REMOVE\nRW FLASH"));		
			gtk_label_set_text (label, txt);		
		break;
/* 		case QR_FLASH_SET_REMOVE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((QRflash_f & mask) == 0) sprintf (txt,_("SET\nQR FLASH"));	
			else sprintf (txt,_("REMOVE\nQR FLASH"));		
			gtk_label_set_text (label, txt);		
		break; */
		case FLASH_AT_SENSOR_TYPE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((machine_paramTmp.ATflash[setupHeadNr].sensor_type & 0x01) == 0) sprintf (txt,_("Sensor type 350"));	
			else sprintf (txt,_("Sensor type 450"));		
			gtk_label_set_text (label, txt);		
		break;	
		case FLASH_AT_PREHEAT_F: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((machine_paramTmp.ATflash[setupHeadNr].preheat_f & 0x01) == 0) sprintf (txt,_("Preheat OFF"));	
			else sprintf (txt,_("Preheat ON"));		
			gtk_label_set_text (label, txt);		
		break;	
		case FLASH_AT_SOCKET_NR: 
		case FLASH_RW_SOCKET_NR: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("Flash socket nr %d"),flashSocNr+1);		
			gtk_label_set_text (label, txt);		
		break;						
/* 		case FLASH_RW_PREHEAT_ON_OFF: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((machine_paramTmp.RWflash[setupHeadNr].preheat_f & 0x01) == 0) sprintf (txt,_("Preheat OFF"));	
			else sprintf (txt,_("Preheat ON"));		
			gtk_label_set_text (label, txt);		
		break; */
/* 		case FLASH_QR_HOME: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("HOME\nFLASH"));	
			gtk_label_set_text (label, txt);		
		break; 
		case FLASH_QR_PREHEAT_ON_OFF: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((machine_paramTmp.QRflash[setupHeadNr].preheat_f & 0x01) == 0) sprintf (txt,_("Preheat OFF"));	
			else sprintf (txt,_("Preheat ON"));		
			gtk_label_set_text (label, txt);		
		break; */
		
/*******	INDEX setupWindowS			*******/
		case INDEX_ENABLE_DISABLE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((idx_en_f & 0x01) == 0) sprintf (txt,_("DISABLE"));	
			else sprintf (txt,_("ENABLE"));				
			gtk_label_set_text (label, txt);
		break;
		case INDEX_CHANGE_DIRECTION: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((idx_dir_f & 0x01) == 0) sprintf (txt,_("CW"));	
			else sprintf (txt,_("CCW"));				
			gtk_label_set_text (label, txt);			
		break;
		case HALF_INDEX_RIGHT: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("HALF\nRIGHT"));	
			gtk_label_set_text (label, txt);		
		break;
		case HALF_INDEX_LEFT: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("HALF\nLEFT"));	
			gtk_label_set_text (label, txt);		
		break;
		case INDEX_HOME: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("INDEX\nHOME"));	
			gtk_label_set_text (label, txt);		
		break;
		case INDEX_RIGHT: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("INDEX\nRIGHT"));	
			gtk_label_set_text (label, txt);		
		break; 
		case INDEX_LEFT: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("INDEX\nLEFT"));	
			gtk_label_set_text (label, txt);		
		break;

/*******	LIFT setupWindowS			*******/
		case LIFT_ENABLE_DISABLE: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			if ((lift_en_f & 0x01) == 0) sprintf (txt,_("DISABLE"));	
			else sprintf (txt,_("ENABLE"));				
			gtk_label_set_text (label, txt);
		break;
		case LIFT_HOME: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("LIFT\nHOME"));	
			gtk_label_set_text (label, txt);		
		break;
		case LIFT_UP: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("LIFT\nUP"));	
			gtk_label_set_text (label, txt);		
		break; 
		case LIFT_DOWN: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("LIFT\nDOWN"));	
			gtk_label_set_text (label, txt);		
		break;

		
/*******	SAVE RECALL BUTTONS		*******/
		case SAVE_JOB: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("SAVE\nJOB"));	
			gtk_label_set_text (label, txt);		
		break;
		case EDIT_JOB:
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("EDIT\nJOB"));	
			gtk_label_set_text (label, txt);
		break;
		case RECALL_JOB: 
			label = lookup_widget (GTK_WIDGET(setupWindow),txt); 
			sprintf (txt,_("RECALL\nJOB"));	
			gtk_label_set_text (label, txt);		
		break;		
	} 
}			


void
startLog			      (GtkButton       *button,
                                        unsigned int         data)
{
	GtkWidget *logLabel, *logTable, *viewport;
	char txt[150],txt2[30]="";
	
	logWindow = create_logWindow ();
	gtk_widget_show (logWindow);
	gtk_widget_set_name( logWindow, "log" );

	paramNr=data;
	paramData(&machine_paramTmp);

	logTable = lookup_widget(GTK_WIDGET(logWindow),"logTable");
	sprintf (txt, "\n%s\n",parameter.name );
	
	viewport = gtk_viewport_new (NULL, NULL);

	switch (parameter.aut_level)
	{
		case 0: gtk_widget_set_name (viewport,"paramNamelog0");break;
		case 1: gtk_widget_set_name (viewport,"paramNamelog1");break;
		case 2: gtk_widget_set_name (viewport,"paramNamelog2");break;
	}

  	gtk_widget_show (viewport);
	gtk_table_attach (GTK_TABLE (logTable), viewport, 0, 4, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
	gtk_viewport_set_shadow_type (GTK_VIEWPORT (viewport), GTK_SHADOW_ETCHED_OUT);

	logLabel = gtk_label_new (txt);
	gtk_widget_set_name (logLabel,"paramNameLogLabel");
	gtk_widget_show (logLabel);
	gtk_container_add (GTK_CONTAINER (viewport), logLabel);

	logLabel = lookup_widget(GTK_WIDGET(logWindow),"paramDatalogLabel");
	
	sprintf(txt, "%s\n", parameter.descr);

	strcat (txt, "\nMAX = ");	
	paramDataPrint (&txt2,parameter.max,parameter.prec);
	strcat (txt,txt2);
	
	strcat (txt, "  MIN = ");
	paramDataPrint (&txt2,parameter.min,parameter.prec);
	strcat (txt,txt2);

	strcat (txt, "  STEP = ");
	paramDataPrint (&txt2,parameter.step,parameter.prec);
	strcat (txt,txt2);
	
	strcat (txt, "\nDEFAULT = ");
	paramDataPrint (&txt2,parameter.def,parameter.prec);
	strcat (txt,txt2);
		
	gtk_label_set_text (logLabel, txt );
	logBegin = 1;
	logValue = parameter.min + *(parameter.value) * parameter.step;
	logOn (logWindow,-9);
}


void
logOn                                    (GtkButton       *button,
                                        int        data)
{
	GtkWidget *entry;
	char txt[30]="",tmp[30]="", i;
	
	switch (data)
	{
	//sign
		case -1:logValue *= -1; 
			logOn(button, -9); break;
	//delete
		case -3:logValue = 0;
			logBegin = 1;
			logOn(button, -9); break;
	//default
		case -4:*(parameter.value) = (parameter.def-parameter.min)/parameter.step;
			if ((allHeads == 1) && (paramNr <= head_jog_vel) && (paramNr >= head_print_vel)) setParamOnAllHeads ();
			refreshLabel();
			logOn(button, -5); break;
	//cancel
		case -5:logValue=0;
			gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button))); break;
	//ok
		case -6:if (logValue > parameter.max) logValue = parameter.max;
			if (logValue < parameter.min) logValue = parameter.min;
			*(parameter.value) = (logValue-parameter.min)/parameter.step;
			if ((allHeads == 1) && (paramNr <= head_jog_vel) && (paramNr >= head_print_vel)) setParamOnAllHeads (); 
			refreshLabel();
			logOn(button, -5); break;
	//step down	
		case -7:logValue -= parameter.step;
			logOn (button,-9);  break;
	//step up
		case -8:logValue += parameter.step;
			logOn (button,-9);  break; 
	//refresh entry
		case -9:if (logValue > parameter.max) logValue = parameter.max;
			if (logValue < -parameter.max) logValue = -parameter.max;
			
			/* if ((logValue>parameter.max)&&(logValue>0)) logValue=parameter.max;
			if ((logValue<0)&&(logValue<parameter.min)) logValue=parameter.min;			 */
			
			entry = lookup_widget(GTK_WIDGET(button),"logEntry");
			paramDataPrint(&tmp,logValue,parameter.prec);
			for (i=1;i+strlen(tmp)<23;i++) 	strcat(txt," ");
			strcat(txt,tmp);
			strcat(txt," ");
			strcat(txt,parameter.unit);
			gtk_entry_set_text (GTK_ENTRY (entry), txt); break;
	//00
		case -10:logOn(button,0);
			logOn(button,0); break;
		
		default : if (logBegin == 1)
			{
				logValue = 0;
				logBegin = 0;
			}
			logValue *= 10;
			logValue += data; 
			logOn(button,-9);
		break;
	}
}


void 
paramValuePrint (char *txt)
{
	int value;
	
	value = parameter.min + *(parameter.value) * parameter.step;
	paramDataPrint(txt, value, parameter.prec);
	strcat(txt," ");
	strcat(txt,parameter.unit);
}


void 
paramDataPrint (char *txt, int value, int prec)
{
	int intvalue, floatvalue=0;
	char tekst[30]="";
	
	if (prec==0) prec=1;
	
	intvalue = value/prec;
	floatvalue = value-intvalue*prec;
	
	if (value<0) 
	{
		intvalue *=-1;
		floatvalue *=-1;
		sprintf(txt,"-%d",intvalue);
	} else sprintf(txt,"%d",intvalue); 
	
	if (prec!=1) strcat(txt,",");
	while (prec>1)
	{
		prec /=10;
		intvalue = floatvalue/prec;
		sprintf(tekst,"%d",intvalue); 		
		floatvalue -= intvalue*prec;
		strcat(txt,tekst);
	}
}


void
refreshLabel 	() 
{
	char txt[30];
	
	paramData(&machine_paramTmp);
	paramValuePrint(&txt);
	gtk_label_set_text (paramLabel[paramNr], txt);
}


void
refreshFlash 	()
{
	GtkWidget *at, *qr, *rw, *notebook;
	unsigned int mask=0x01;
	
	notebook = lookup_widget(GTK_WIDGET(setupWindow),"flashNotebook");
	at = lookup_widget(GTK_WIDGET(setupWindow),"flashATSetupBox");
	qr = lookup_widget(GTK_WIDGET(setupWindow),"flashQRSetupBox");
	rw = lookup_widget(GTK_WIDGET(setupWindow),"flashRWSetupBox");		
	
	mask <<= setupHeadNr;

        if ((ATflash_f & mask) != 0) 
	{
		gtk_widget_show(at);
		paramNr = flash_AT_cure_time; 	refreshLabel ();
		paramNr = flash_AT_temp; 	refreshLabel ();
		paramNr = flash_AT_stby_time; 	refreshLabel (); 
		paramNr = flash_AT_stby_power; 	refreshLabel (); 
		paramNr = flash_AT_warm_up_time; refreshLabel (); 
		
		setCtrlButtonName (buttonNr=FLASH_AT_SENSOR_TYPE);
	}	else gtk_widget_hide(at);
	
/*         if ((QRflash_f & mask) != 0) 
	{
		gtk_widget_show(qr);
		paramNr = flash_QR_scan_dist; 	refreshLabel ();
		paramNr = flash_QR_scan_vel; 	refreshLabel ();
		paramNr = flash_QR_appr_dist; 	refreshLabel ();
		paramNr = flash_QR_appr_vel; 	refreshLabel ();
		paramNr = flash_QR_nr_of_scans; refreshLabel ();
		
		setCtrlButtonName (buttonNr=FLASH_QR_PREHEAT_ON_OFF);
	}	else */ gtk_widget_hide(qr);
	
        if ((RWflash_f & mask) != 0) 
	{
		gtk_widget_show(rw);
/* 		paramNr = flash_RW_preheat_time; refreshLabel (); */
		paramNr = flash_RW_cure_time; 	refreshLabel ();
		
/* 		setCtrlButtonName (buttonNr=FLASH_RW_PREHEAT_ON_OFF); */
	}	else gtk_widget_hide(rw);
	
	if (allHeads == 1)		
	{
		gtk_widget_hide(at);
		gtk_widget_hide(qr);
		gtk_widget_hide(rw);
	}
}


void   
refreshHead	()
{
	char txt[30],tmpHeadNr=setupHeadNr;
	unsigned int tmpVal;
	unsigned int startParNr;
	unsigned int endParNr;

	paramNr=head_print_vel;
	startParNr = paramNr;
	paramNr=head_jog_vel;
	endParNr = paramNr;
	
	if (allHeads == 1)	for (paramNr=startParNr;paramNr<=endParNr;paramNr++)
	{
		setupHeadNr=0;
		paramData(&machine_paramTmp);
		paramValuePrint(&txt);
		tmpVal = *(parameter.value);
		for (setupHeadNr=1;setupHeadNr<mach_size-2;setupHeadNr++)
		{
			paramData(&machine_paramTmp);
			if (tmpVal != *(parameter.value))
			{
				strcpy (txt,"-----");
				break;
			}
		}
		gtk_label_set_text (paramLabel[paramNr], txt);
 		setupHeadNr = tmpHeadNr;
	}

	else	for (paramNr=startParNr;paramNr<=endParNr;paramNr++)
		{
			paramData(&machine_paramTmp);
			paramValuePrint(&txt);
			gtk_label_set_text (paramLabel[paramNr], txt);
		}
		
	setCtrlButtonName (buttonNr=HEAD_ENABLE_DISABLE);
	setCtrlButtonName (buttonNr=AT_FLASH_SET_REMOVE);		
	setCtrlButtonName (buttonNr=RW_FLASH_SET_REMOVE);	
/* 	setCtrlButtonName (buttonNr=QR_FLASH_SET_REMOVE);	
	setCtrlButtonName (buttonNr=FLASH_QR_PREHEAT_ON_OFF);	
	setCtrlButtonName (buttonNr=FLASH_RW_PREHEAT_ON_OFF); */
}


void
refreshAll	()
{
	unsigned int start;
	unsigned int end;
	char txt[30];
	
	paramNr=first;	start = paramNr;
	paramNr=last;	end = paramNr;
	for (paramNr=start+1;paramNr<end;paramNr++)
		{
			paramData(&machine_paramTmp);
			paramValuePrint(&txt);
			gtk_label_set_text (paramLabel[paramNr], txt);
		}
	
	buttonNr=FIRST;	start = buttonNr;
	buttonNr=LAST;	end = buttonNr;
	for (buttonNr=start+1;buttonNr<end;buttonNr++)	setCtrlButtonName (buttonNr);
	
}

void
refreshJob ()
{
	
	if ((fileName == 0) && (openFilesDescr ())) fileName = 1;
		
	gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"fileLabel"), files[fileName-1].fileName );
	
	if(fileName >= 3) gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file1Label"), files[fileName-3].fileName );
	else gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file1Label"), "" );
	if(fileName >= 2) gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file2Label"), files[fileName-2].fileName );
	else gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file2Label"), "" );
	if(fileName <= 9) gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file3Label"), files[fileName].fileName );
	else gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file3Label"), "" );
	if(fileName <= 10) gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file4Label"), files[fileName+1].fileName );
	else gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"file4Label"), "" );	
}


gboolean 
head2soc (int selector)
{
const char nrOfSockets = 4;
char i; 
static char j[4];

	switch (selector)
	{
		case 0://check head2soc (socket_f) setup & initialize flash_soc array and flash flags
			for (i=0; i < nrOfSockets; i++) j[i]=0;
			ATflash_f = 0;
			RWflash_f = 0;
			for (i=mach_size-3; i>=0; i--)
			{
				if ((machine_param.RWflash[i].socket_f > 0)&&(machine_param.RWflash[i].socket_f <=
				nrOfSockets)&&(j[machine_param.RWflash[i].socket_f-1] == 0))
				{
					RWflash_f |= 0x01<<i;
					j[machine_param.RWflash[i].socket_f-1] = i+1;
					machine_param.ATflash[i].socket_f = 0;
				} else {
					machine_param.RWflash[i].socket_f = 0;
					RWflash_f &= ~(0x01<<i);
				}
				if ((machine_param.ATflash[i].socket_f > 0)&&(machine_param.ATflash[i].socket_f <=
				nrOfSockets)&&(j[machine_param.ATflash[i].socket_f-1] == 0))
				{
					ATflash_f |= 0x01<<i;
					j[machine_param.ATflash[i].socket_f-1] = i+1;
				} else {
					machine_param.ATflash[i].socket_f = 0;
					ATflash_f &= ~(0x01<<i);
				}
			}
			return TRUE;
		break;
		case 1://refresh label on flash socket button
			if (machine_paramTmp.ATflash[setupHeadNr].socket_f != 0) flashSocNr = machine_paramTmp.ATflash[setupHeadNr].socket_f - 1;
			if (machine_paramTmp.RWflash[setupHeadNr].socket_f != 0) flashSocNr = machine_paramTmp.RWflash[setupHeadNr].socket_f - 1;
			setCtrlButtonName(FLASH_AT_SOCKET_NR);
			setCtrlButtonName(FLASH_RW_SOCKET_NR);	
			return TRUE;
		break;
		case 2: //look_for free socket in parameters
			for (i=0; i < nrOfSockets; i++) j[i]=0;
			for (i=0; i<mach_size-2; i++) 
			{
				if (machine_param.ATflash[i].socket_f != 0) j[machine_param.ATflash[i].socket_f-1] = i+1;
				if (machine_param.RWflash[i].socket_f != 0) j[machine_param.RWflash[i].socket_f-1] = i+1;
			}	
			for (i=0; i<nrOfSockets; i++) if (j[i] == 0)
				{
					flashSocNr = i;
					return TRUE;
				}		
		break;
		case 3: //look_for free socket in temporary parameters
			for (i=0; i < nrOfSockets; i++) j[i]=0;
			for (i=0; i<mach_size-2; i++) 
			{
				if (machine_paramTmp.ATflash[i].socket_f != 0) j[machine_paramTmp.ATflash[i].socket_f-1] = i+1;
				if (machine_paramTmp.RWflash[i].socket_f != 0) j[machine_paramTmp.RWflash[i].socket_f-1] = i+1;
			}
			for (i=flashSocNr+1; i<nrOfSockets; i++) if (j[i] == 0)
				{
					flashSocNr = i;
					return TRUE;
				}
			for (i=0; i<=flashSocNr; i++) if (j[i] == 0)
				{
					flashSocNr = i;
					return TRUE;
				}
		break;
		case 4://rebuild flash heads
			ATflash_f = 0;
			RWflash_f = 0;
			for (i=mach_size-3; i>=0; i--) 
			{
				if ((machine_param.ATflash[i].socket_f != 0) || (machine_paramTmp.ATflash[i].socket_f != 0))
				{
					machine_param.ATflash[i].socket_f = machine_paramTmp.ATflash[i].socket_f;
					if (machine_param.ATflash[i].socket_f != 0) ATflash_f |= 0x01 << i;
					rebuildHead(i);
				}
				if ((machine_param.RWflash[i].socket_f != 0) || (machine_paramTmp.RWflash[i].socket_f != 0))
				{
					machine_param.RWflash[i].socket_f = machine_paramTmp.RWflash[i].socket_f;
					if (machine_param.RWflash[i].socket_f != 0) RWflash_f |= 0x01 << i;					
					rebuildHead(i);				
				}				
			}
			
		break;		
	}
return FALSE;
}


void 
setParamOnAllHeads	()
{
	char tmpHeadNr=setupHeadNr;
	unsigned int tmpVal = *(parameter.value);
	
	for (setupHeadNr=0;setupHeadNr<mach_size-2;setupHeadNr++)
	{
		paramData(&machine_paramTmp);
		*(parameter.value) = tmpVal;
	}
		setupHeadNr = tmpHeadNr;
}		
 

void
selHead                                (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        int         data)
{
	char txt[30]; 
	
	switch (data)
	{
	//next head
		case 1:	if (setupHeadNr<mach_size-3) 	{if (allHeads == 0) setupHeadNr++;
							else allHeads = 0;}
			else allHeads=1;break;			
	//prev head
		case 2:if (setupHeadNr>0) 		{if (allHeads == 0) setupHeadNr--;
							else allHeads = 0;}
			else allHeads=1;break;		
	}
	if (allHeads == 1) sprintf (txt,"all heads");
	else sprintf (txt,"head nr %d", setupHeadNr+1);
	gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"selHead_HeadLabel"), txt );
	gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"selHead_FlashLabel"), txt );
	
	refreshFlash ();
	refreshHead ();
	head2soc(1);
}


void
login                                  (GtkButton       *button,
                                        int         data)
{
	extern int busfd;
	GtkWidget *ctrlPanel;
	switch (data)
	{
	//invoke
		case 10:loginWindow = create_loginWindow ();
			gtk_widget_show (loginWindow); break;
	//login
		case -1: switch (loginValue)
			{
				case 3691215: 
					autorizationLevel = 1; 
				break;
				case 36912150:
					if (((show_hide_f ^= 0x08) & 0x08) != 0) gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
					else gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
				break;				
				case 3216842: 
					autorizationLevel = 2; 
				break;
				case 321684200: f_can_close(busfd); gtk_exit(0); break;
				default :
					autorizationLevel = 0; 
				break; 								
			}
			gtk_widget_destroy(setupWindow);
			showSetup();
			login(button,-2);break;
	//cancel
		case -2:loginValue = 0;
			gtk_widget_destroy(loginWindow); break;
		
		default:loginValue *= 10;
			loginValue += data; break;
	}
}


void
selFile                                (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        int         data)
{
	GtkWidget *label;
	char txt[30];
	
	switch (data)
	{
	//prev file
		case 1: if (fileName > 1) 	 fileName--;	break;
	//next file
		case 2:	if (fileName < 10) 	 fileName++;	break;	
	}
	refreshJob();
}


void
job                                    (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned char i=0, j, k=0, textLen;
char text[256]="", hiText[256]="", loText[256]="";
static char nameText[31], descrText[256];
static unsigned char jobFlag, jobTextPos;
const GtkWidget *nameLabel = lookup_widget(GTK_WIDGET(jobWindow),"nameJobLabel");
const GtkWidget *descrLabel = lookup_widget(GTK_WIDGET(jobWindow),"descrJobLabel"); 


strcpy(text,user_data);
i=text[0];
//if (jobFlag != 1) jobFlag = 0;

switch (i)
{
	case 'x': //exit
		gtk_widget_destroy(jobWindow);
		saveFilesDescr ();
		refreshJob();
		return;
	break;
	case 'n': //name
		jobFlag = 1;
	break;
	case 'o': //descripion
		jobFlag = 0;
	break;
	case 'f': // first loop
		strcpy(nameText, files[fileName-1].fileName);
		strcpy(descrText, files[fileName-1].fileDescr);
		jobTextPos = 0;		
	break;		
}
textLen = (jobFlag == 1) ? strlen (nameText) : strlen (descrText);
switch (i)
{
	case 'n': //name
	case 'o': //descripion
	case '-': //last
		jobTextPos = textLen;
	break;	
	case '+': //first
		jobTextPos = 0;
	break;
	case '<': //left
		if (jobTextPos > 0) jobTextPos--;
	break;
	case '>': //right
		if (jobTextPos < textLen) jobTextPos++;
	break;
}

if (jobFlag == 1)
{
	for (j = 0; j < jobTextPos; j++) hiText[j] = nameText[j];
	for (; j <= textLen; j++) loText[j-jobTextPos] = nameText[j];
} else {
	for (j = 0; j < jobTextPos; j++) hiText[j] = descrText[j];
	for (; j <= textLen; j++) loText[j-jobTextPos] = descrText[j];
}

switch (i)
{
	case 'x': 	break;
	case 'n': 	break;
	case 'o':	break;
	case '+':	break;
	case '-':	break;			
	case '<':	break;
	case '>':	break;
	case 'f': 	break;
	case 's': // save
		strcpy(files[fileName-1].fileName, nameText);
		strcpy(files[fileName-1].fileDescr, descrText);
	break;
	case 'd': //delete 
		strcpy(files[fileName-1].fileName, "empty");
		strcpy(files[fileName-1].fileDescr, "");	
	break;
	case 'b': //back space
		if (jobTextPos > 0) 
		{
			hiText[jobTextPos-1] = 0;
			jobTextPos--;
		}
	break;
	default: 
		if (((jobFlag == 1) && (strlen(nameText)<29)) || ((jobFlag != 1) && ((strlen(descrText)<254))))
		{
			hiText[jobTextPos] = i;
			jobTextPos++;
		}
		
}

if (jobFlag)
{
	sprintf(text,"%s%s%s",hiText,"_",loText);
	gtk_label_set_text (nameLabel, text);
	sprintf(nameText,"%s%s",hiText,loText);
	gtk_label_set_text (descrLabel, descrText);
} else {
	sprintf(text,"%s%s%s",hiText,"_",loText);
	gtk_label_set_text (descrLabel, text);
	sprintf(descrText,"%s%s",hiText,loText);	
	gtk_label_set_text (nameLabel, nameText);
}
}









