#include "global.h"
#include <gnome.h>

#include "Can.h"
#include "CanOpenMatic.h"
#include "CanOpener.h"
#include "Can4Open.h"
#include "movements.h"


void
printState(char state[50])
{
  gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"stateLabel"), state);
}


void
printMsg(char msg[150])
{
GtkWidget *msgEntry;

  msgEntry = lookup_widget (GTK_WIDGET(mainWindow),"msgEntry");
  gtk_text_insert (GTK_TEXT (msgEntry), NULL, NULL, NULL,
                   msg, strlen(msg));
  
  
//  gtk_entry_set_text (GTK_ENTRY (msgEntry), msg);
}


void
refreshCounters()
{
	GtkWidget *counterLabel;
	char txt[30];

	counterLabel = lookup_widget (GTK_WIDGET(mainWindow),"totalCountLabel");
	sprintf (txt,"%d total", totalCount);
	gtk_label_set_text (counterLabel, txt);

	counterLabel = lookup_widget (GTK_WIDGET(mainWindow),"lastCountLabel");
	sprintf (txt,"%d last", lastCount);
	gtk_label_set_text (counterLabel, txt);
}

void
refreshWheel()
{
        GtkWidget *widget;
	char i, txt[30];
	unsigned int mask=0x01;

	for (i=0; i<(mach_size-2);i++)
	{
		sprintf(txt,"h%.2dtshirtPix",i+1);
		widget = lookup_widget(GTK_WIDGET(mainWindow),txt);
	        if ((tshirt_f & mask<<i) != 0) gtk_widget_show(widget);
	        else gtk_widget_hide(widget);

		sprintf(txt,"h%.2doffPix",i+1);
		widget = lookup_widget(GTK_WIDGET(mainWindow),txt);
	        if ((en_head_f & mask<<i) == 0) gtk_widget_show(widget);
	        else gtk_widget_hide(widget);		
		
		if ((ATflash_f & mask<<i) != 0) 
		{
		    sprintf (txt, "AT%dLabel",i+1);
		    widget = lookup_widget(GTK_WIDGET(mainWindow),txt);
		    sprintf (txt, "%d F", AT_temp[i]);
		    gtk_label_set_text(widget,txt);
		}
	}
}

gboolean 
start_stop (void)
{
	return TRUE;
}

void
refreshStartStop	()
{
GtkWidget *startPix, *stopPix;

extern unsigned int work_f;

if (start_stop())
{
	startPix = lookup_widget(GTK_WIDGET(mainWindow),"startPix");
	stopPix = lookup_widget(GTK_WIDGET(mainWindow),"stopPix");

	if (work_f == 0)
	{
		work_f = 0x01;
		gtk_widget_hide (startPix);
		gtk_widget_show (stopPix);
	} else {
		work_f = 0x00;
		gtk_widget_show (startPix);
		gtk_widget_hide (stopPix);
	}
}
}

void
on_startStopBox_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         data)
{
  refreshStartStop();
}


gboolean
on_skipBox_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  skip_f = 1;
  return FALSE;
}

gboolean
on_printfBox_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  print_finish_f = 1;
  return FALSE;
}

void
panelButtonPressed                     (GtkButton       *widget,
                                        int         user_data)
{
	int x, z, head_in_home;
	char txt[30];

	switch (user_data)
	{
		case 1: 	//dwell minus
			widget = lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel");
			paramNr = dwell_time;
			paramData(&machine_param);
			if (*parameter.value != parameter.min) *parameter.value -= parameter.step;
			paramValuePrint(&txt);
			gtk_label_set_text (widget, txt);
		break;
		case 2: 	//dwell plus
			widget = lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel");
			paramNr = dwell_time;
			paramData(&machine_param);
			if (*parameter.value != parameter.max) *parameter.value += parameter.step;
			paramValuePrint(&txt);
			gtk_label_set_text (widget, txt);		
		break;
		case 3: 	//full left
			{
				move_idx_left(IDX_BOARD);
				break;
			}
		case 4: 	//full right
			{
				move_idx_right(IDX_BOARD);
				break;
			}
		case 5: 	//table
			{
//			    if (reset_f == 0)
//			    {
				if (lift_up_pos == 1) move_lift_down_check(IDX_BOARD);
				else move_lift_up_check(IDX_BOARD);
//			    }
			    break;
			}
		case 6: 	//half left
			{
				move_hidx_left(IDX_BOARD);
				break;
			}
		case 7: 	//half right
			{
				move_hidx_right(IDX_BOARD);
				break;
			}
		case 8: 	//test print
			{
				print_stage = 7;
				do
				{
				    usleep(10000);
				    print_cycle(10);
				}while(1);
				break;
			}
		case 9: 	//reset
			{
				print_stage = 5;
				reset_f = 1;
				home_f = 0x00;
				refreshStatus();
				break;
			}
/* 		case 10: 	//free wheel
			wheel_f ^= 0x01;
			refreshStatus();
		break; */
		case 11: 	//home
		{
		    //move to home all heads
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & (~ATflash_f) & (~RWflash_f) & x)
			{
			    usleep(1000);
			    move_squee_up(z);
			    usleep(1000);
			    move_flood_up(z);
			    usleep(1000);
			    head_home(z);
			}
			x <<= 1;
		    }

		    idx_homing = 0;
		    idx_home(IDX_BOARD);

		    if (idx_homing == 1) {lift_home(IDX_BOARD);}
		    else {printState(_("Homing not completed")); home_f=0; break;}

		    if (lift_homing == 0) {printState(_("Homing not completed")); home_f=0; break;}

		    //check heads in home
		    head_in_home = 0x00;
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
		        if (en_head_f & (~ATflash_f) & (~RWflash_f) & x)
		        {
			    usleep(1000);
    			    if (check_head_home(z)) {head_in_home |= x;}
			}
			x <<= 1;
		    }
		    if ((head_in_home & en_head_f & (~ATflash_f) & (~RWflash_f)) != head_in_home) {printState(_("Home not completed")); home_f=0;}
		    else {printState(_("Homing done")); home_f=1;}

		    //move head posB
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & (~ATflash_f) & (~RWflash_f) & x)
			{
			    usleep(1000);
			    move_head_posB(z);
			}
			x <<= 1;
		    }
			refreshStatus();
		    break;
		}

		default:
	}
}

void 
controlButtonPressed (GtkButton *button, int buttonNr)
{
	int x, z, head_in_home;
	unsigned int mask=0x01;
	char txt[30];
	GtkWidget *widget;
	
	mask <<= setupHeadNr;
	switch (buttonNr)
	{
		case HIDE_COUNTERS:
			show_hide_f ^= 0x04;
			setCtrlButtonName(buttonNr);
			widget = lookup_widget(GTK_WIDGET(mainWindow),"countersFrame");
			if ((show_hide_f & 0x04) != 0)	gtk_widget_hide (widget);
			else  gtk_widget_show (widget);
		break;
		case RESET_COUNTER:
			lastCount = 0;
			refreshCounters();
		break;
		//case FREE_WHEEL: break;
		case TABLE_UP_DOWN:
			{
				if (lift_up_pos == 1) move_lift_down_check(IDX_BOARD);
				else move_lift_up_check(IDX_BOARD);
				break;
			}
		case TEST_PRINT: break;
		case RESET:
			print_stage = 5;
			reset_f = 1;
			home_f = 0x00;
			refreshStatus();
		break;
		case HOME:
		{
		    //move to home all heads
		    printState(_(""));
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & (~ATflash_f) & (~RWflash_f) & x)
			{
			    move_squee_up(z);
			    move_flood_up(z);
			    head_home(z);
			}
			x <<= 1;
		    }

		    idx_homing = 0;
		    idx_home(IDX_BOARD);

		    if (idx_homing == 1) {lift_home(IDX_BOARD);}
		    else {printState(_("Homing not completed")); home_f=0; break;}

		    if (lift_homing == 0) {printState(_("Homing not completed")); home_f=0; break;}

		    //check heads in home
		    head_in_home = 0x00;
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
		        if (en_head_f & (~ATflash_f) & (~RWflash_f) & x)
		        {
    			    if (check_head_home(z)) {head_in_home |= x;}
			}
			x <<= 1;
		    }
		    if ((head_in_home & en_head_f & (~ATflash_f) & (~RWflash_f)) != head_in_home) {printState(_("Home not completed")); home_f=0;}
		    else {printState(_("Homing done")); home_f=1;}

		    //move head posB
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if ((~ATflash_f) & (~RWflash_f) & x)
			{
			    move_head_posB(z);
			}
			x <<= 1;
		    }
		refreshStatus();
		break;
		}

		case PANEL_ON_OFF:
			show_hide_f ^= 0x01;
			setCtrlButtonName(buttonNr);
			widget = lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel");
			if ((show_hide_f & 0x01) != 0)	gtk_widget_show (widget);
			else  gtk_widget_hide (widget);
		break;
		case HIDE_STATUS:
			show_hide_f ^= 0x02;
			setCtrlButtonName(buttonNr);
			widget = lookup_widget(GTK_WIDGET(mainWindow),"statusFrame");
			if ((show_hide_f & 0x02) != 0)	gtk_widget_hide (widget);
			else  gtk_widget_show (widget);
		case DWELL_UP:
			widget = lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel");
			paramNr = dwell_time;
			paramData(&machine_param);
			machine_param.dwell_time++;
			if (machine_param.dwell_time>parameter.max) machine_param.dwell_time = parameter.max;
			if (machine_param.dwell_time<parameter.min) machine_param.dwell_time = parameter.min;
			paramValuePrint(&txt);
			gtk_label_set_text (widget, txt);
		break;
		case DWELL_DOWN:
			widget = lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel");
			paramNr = dwell_time;
			paramData(&machine_param);
			machine_param.dwell_time--;
			if (machine_param.dwell_time>parameter.max) machine_param.dwell_time = parameter.max;
			if (machine_param.dwell_time<parameter.min) machine_param.dwell_time = parameter.min;
			paramValuePrint(&txt);
			gtk_label_set_text (widget, txt);
		break;
		case MODE:
			mode_f ^= 0x01;
			setCtrlButtonName(buttonNr);
			refreshStatus();
		break;
		case M_LIFT_DOWN:
			if (machine_paramTmp.m_lift_down == 0) machine_paramTmp.m_lift_down = 1;
			else machine_paramTmp.m_lift_down = 0;
			setCtrlButtonName(buttonNr);
			//refreshStatus();
		break;

/*******	HEAD BUTTONS			*******/
		case HEAD_ENABLE_DISABLE:
			en_head_f ^= mask;
			setCtrlButtonName(buttonNr);
			sprintf(txt,"h%.2doffPix",setupHeadNr+1);
			widget = lookup_widget(GTK_WIDGET(mainWindow),txt);
		        if ((en_head_f & mask) == 0) gtk_widget_show(widget);
		        else gtk_widget_hide(widget);
		break;
		case HEAD_TEST_PRINT: {move_flood_down(setupHeadNr+1); break;}
		case HEAD_HOME:
			{
				head_home(setupHeadNr+1);
				break;
			}

/*******	FLASH BUTTONS			*******/
		case AT_FLASH_SET_REMOVE:
			//head2soc(0);
			if (((ATflash_f & mask) == 0) && head2soc(2))
			{
				ATflash_f |= mask;
				machine_param.ATflash[setupHeadNr].socket_f = flashSocNr+1;
				machine_paramTmp.ATflash[setupHeadNr].socket_f = flashSocNr+1;
				RWflash_f &= ~mask;
				machine_param.RWflash[setupHeadNr].socket_f = 0;
				machine_paramTmp.RWflash[setupHeadNr].socket_f = 0;
			} else if ((ATflash_f & mask) != 0) 
			{
				ATflash_f &= ~mask;
				machine_param.ATflash[setupHeadNr].socket_f = 0;
				machine_paramTmp.ATflash[setupHeadNr].socket_f = 0;
			}
			setCtrlButtonName(buttonNr);	
			setCtrlButtonName(buttonNr=RW_FLASH_SET_REMOVE);
			rebuildHead((char)setupHeadNr);		
			setCtrlButtonName(FLASH_AT_SOCKET_NR);
			setCtrlButtonName(FLASH_RW_SOCKET_NR);							
			refreshFlash ();
		break;
		case RW_FLASH_SET_REMOVE: 
			//head2soc(0);
			if (((RWflash_f & mask) == 0) && head2soc(2))
			{
				RWflash_f |= mask;
				machine_param.RWflash[setupHeadNr].socket_f = flashSocNr+1;
				machine_paramTmp.RWflash[setupHeadNr].socket_f = flashSocNr+1;
				ATflash_f &= ~mask;
				machine_param.ATflash[setupHeadNr].socket_f = 0;
				machine_paramTmp.ATflash[setupHeadNr].socket_f = 0;
			} else if ((RWflash_f & mask) != 0) 
			{
				RWflash_f &= ~mask;
				machine_param.RWflash[setupHeadNr].socket_f = 0;
				machine_paramTmp.RWflash[setupHeadNr].socket_f = 0;
			}
			setCtrlButtonName(buttonNr);	
			setCtrlButtonName(buttonNr=AT_FLASH_SET_REMOVE);
			rebuildHead((char)setupHeadNr);									
			setCtrlButtonName(FLASH_AT_SOCKET_NR);
			setCtrlButtonName(FLASH_RW_SOCKET_NR);
			refreshFlash ();		
		break;
/* 		case QR_FLASH_SET_REMOVE: 
			QRflash_f ^= mask;		
			RWflash_f &= ~mask;
			ATflash_f &= ~mask;			
			setCtrlButtonName(buttonNr);
			setCtrlButtonName(buttonNr=RW_FLASH_SET_REMOVE);
			setCtrlButtonName(buttonNr=AT_FLASH_SET_REMOVE);				
			rebuildHead((char)setupHeadNr);
			refreshFlash ();
		break; */
		case FLASH_AT_SENSOR_TYPE: 
			machine_paramTmp.ATflash[setupHeadNr].sensor_type ^= 0x01;
			setCtrlButtonName(buttonNr);			
		break;
/* 		case FLASH_RW_PREHEAT_ON_OFF: 
			machine_paramTmp.RWflash[setupHeadNr].preheat_f ^= 0x01;
			setCtrlButtonName(buttonNr);			
		break; */
/* 		case FLASH_QR_HOME: break; 
		case FLASH_QR_PREHEAT_ON_OFF: 
			machine_paramTmp.QRflash[setupHeadNr].preheat_f ^= 0x01;
			setCtrlButtonName(buttonNr);
		break; */
		case FLASH_AT_SOCKET_NR: 
			if (head2soc(3))
			{
				machine_paramTmp.ATflash[setupHeadNr].socket_f = flashSocNr+1;
				setCtrlButtonName(buttonNr);
				refreshLevel_f = 0x01;				
			}
		break;	
		case FLASH_RW_SOCKET_NR: 
			if (head2soc(3))
			{
				machine_paramTmp.RWflash[setupHeadNr].socket_f = flashSocNr+1;
				setCtrlButtonName(buttonNr);	
				refreshLevel_f = 0x01;							
			}
		break;		
		case FLASH_AT_PREHEAT_F: 
			machine_paramTmp.ATflash[setupHeadNr].preheat_f ^= 0x01;
			setCtrlButtonName(buttonNr);
		break;		
		
/*******	INDEX BUTTONS			*******/
		case INDEX_ENABLE_DISABLE: 
			  idx_en_f ^= 0x01;
			  setCtrlButtonName(buttonNr);
		  	refreshStatus();
		break;
		case INDEX_CHANGE_DIRECTION: 
			  idx_dir_f ^= 0x01;
			  setCtrlButtonName(buttonNr);	
		  	refreshStatus();	
		break;
		case HALF_INDEX_RIGHT:
			{
				move_hidx_right(IDX_BOARD);
				break;
			}
		case HALF_INDEX_LEFT:
			{
				move_hidx_left(IDX_BOARD);
				break;
			}
		case INDEX_HOME:
			{
				idx_home(IDX_BOARD);
				break;
			}
		case INDEX_RIGHT:
			{
				move_idx_right(IDX_BOARD);
				break;
			}
		case INDEX_LEFT:
			{
				move_idx_left(IDX_BOARD);
				break;
			}

/*******	LIFT BUTTONS			*******/
		case LIFT_ENABLE_DISABLE:
			  lift_en_f ^= 0x01;
			  setCtrlButtonName(buttonNr);
		  	  refreshStatus();
		break;
		case LIFT_HOME:
			{
				lift_home(IDX_BOARD);
				break;
			}
		case LIFT_UP:
			{
				move_lift_up_check(IDX_BOARD);
				break;
			}
		case LIFT_DOWN:
			{
				move_lift_down_check(IDX_BOARD);
				break;
			}

/*******	SAVE RECALL BUTTONS		*******/
		case SAVE_JOB:
			widget = lookup_widget(GTK_WIDGET(setupWindow),"fileLabel");
			sprintf (txt,"par/machine%d.par",fileName);
			if (saveParams (&machine_paramTmp, txt))
			{
				gtk_label_set_text (widget, _("Job saved"));
				if (strcmp(files[fileName-1].fileName, "empty") == 0)
				{
					sprintf(txt,"JOB NR %d",fileName);
					strcpy(files[fileName-1].fileName, txt);
					jobWindow = create_jobWindow ();
	  				gtk_widget_show (jobWindow);
					job (button, "f");
				}				
			} else gtk_label_set_text (widget, _("Operation filed"));
		break;
		case EDIT_JOB:
			if (strcmp(files[fileName-1].fileName, "empty") != 0)
			{
				jobWindow = create_jobWindow ();
  				gtk_widget_show (jobWindow);
				job (button, "f");		
			} else gtk_label_set_text (lookup_widget(GTK_WIDGET(setupWindow),"fileLabel"), _("Operation filed"));
		break;
		case RECALL_JOB: 
			widget = lookup_widget(GTK_WIDGET(setupWindow),"fileLabel");			
			sprintf (txt,"par/machine%d.par",fileName);
			if ((strcmp(files[fileName-1].fileName, "empty") != 0) && openParams (&machine_paramTmp, txt)) gtk_label_set_text (widget, _("Job recalled"));
			else {
				gtk_label_set_text (widget, _("Operation filed"));	
				machine_paramTmp = machine_param;
			}
			refreshAll();
			if (allHeads == 1) refreshHead();
			refreshLevel_f = 0x01;			
		break;
		
	} 
}



void
paramData	(struct vind_param *param)
{
switch (paramNr)
{
case machine_size:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Machine size");
	strcpy (parameter.descr, "Enter number of arms (nr of heads + 2)");
	strcpy (parameter.unit, " ");
	parameter.max = 22 ; 
	parameter.min = 6  ; 
	parameter.step = 1 ;
	parameter.def = 12 ; 
	parameter.value = &param->mach_size; 
break;
case dwell_time:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Dwell time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 50 ; 
	parameter.min = 0  ; 
	parameter.step = 1 ; 
	parameter.def = 5 ; 
	parameter.value = &param->dwell_time; 
break;
case off_contact:
	parameter.prec = 1000 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Off contact");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 5000 ; 
	parameter.min = 0  ; 
	parameter.step = 1 ; 
	parameter.def = 0 ; 
	parameter.value = &param->off_contact; 
break;
case head_flood_delay:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Flood delay");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 10 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->flood_delay; break;
case head_print_delay:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Print delay");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 10 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;
	parameter.value = &param->print_delay; break;

/*******	HEAD PARAMETERS		*******/

case head_print_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Print velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 50 ; 
	parameter.min = 1  ; 
	parameter.step = 1 ; 
	parameter.def = 1 ; 
	parameter.value = &param->head[setupHeadNr].print_vel; 
break;
case head_flood_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Flood velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 50 ; 
	parameter.min =  1 ; 
	parameter.step = 1 ; 
	parameter.def = 1 ; 
	parameter.value = &param->head[setupHeadNr].flood_vel; 
break;
case head_front_pos:
	parameter.prec = 100 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Front position");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 3500 - param->head[setupHeadNr].rear_pos ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->head[setupHeadNr].front_pos; break;
case head_rear_pos:
	parameter.prec = 100 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Rear position");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 3500 - param->head[setupHeadNr].front_pos;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->head[setupHeadNr].rear_pos; break;
case head_home_offset:
	parameter.prec = 100 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home offset");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 100 ;   
	parameter.min = 0 ;
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->head[setupHeadNr].home_offset; break;
case head_home_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 10 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;  
	parameter.def = 1 ;  
	parameter.value = &param->head[setupHeadNr].home_vel; break;
case head_jog_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Jog velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 20 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;  
	parameter.def = 1 ;  
	parameter.value = &param->head[setupHeadNr].jog_vel; break;
case head_m_print:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Nr of prints");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "");
	parameter.max = 4 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;  
	parameter.def = 1 ;  
	parameter.value = &param->head[setupHeadNr].m_print; break;

/*******	FLASH PARAMETERS		*******/

case flash_AT_cure_time:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Cure time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 300 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->ATflash[setupHeadNr].cure_time;  break;
case flash_AT_temp:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Temperature");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "F");
	parameter.max = 400 ;  
	parameter.min = 32 ;  
	parameter.step = 1 ;  
	parameter.def = 32 ;  
	parameter.value = &param->ATflash[setupHeadNr].temp;  break;
case flash_AT_stby_time:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Standby time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 60 ;  
	parameter.min = 0 ;
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->ATflash[setupHeadNr].stby_time;  break;
case flash_AT_stby_power:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Standby power");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "%");
	parameter.max = 100 ;  
	parameter.min = 0 ;  
	parameter.step = 5 ;  
	parameter.def = 0 ;  
	parameter.value = &param->ATflash[setupHeadNr].stby_power;  break;
case flash_AT_warm_up_time:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Warm up time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 45 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->ATflash[setupHeadNr].warm_up_time;  break;


/* case flash_QR_scan_dist:
	parameter.prec = 100 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Scan distance");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 2750 ;  
	parameter.min = 0 ;  
	parameter.step = 25 ;  
	parameter.def = 2750 ;  
	parameter.value = &param->QRflash[setupHeadNr].scan_dist;  break;
case flash_QR_scan_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Scan velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 60 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;  
	parameter.def = 1 ;
	parameter.value = &param->QRflash[setupHeadNr].scan_vel;  break;
case flash_QR_appr_dist:
	parameter.prec = 100 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Approach distance");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 2750 ;  
	parameter.min = 0 ;  
	parameter.step = 25 ;  
	parameter.def = 0 ;  
	parameter.value = &param->QRflash[setupHeadNr].appr_dist;  break;
case flash_QR_appr_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Approach velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in/s");
	parameter.max = 60 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;  
	parameter.def = 1 ;  
	parameter.value = &param->QRflash[setupHeadNr].appr_vel;  break;
case flash_QR_nr_of_scans:
	parameter.prec = 1 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Number of scans");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, " ");
	parameter.max = 10 ;  
	parameter.min = 1 ;  
	parameter.step = 1 ;
	parameter.def = 1 ;  
	parameter.value = &param->QRflash[setupHeadNr].nr_of_scans;  break;
 */

/* case flash_RW_preheat_time:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Preheat time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 20 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 10 ;  
	parameter.value = &param->RWflash[setupHeadNr].preheat_time;  break; */
case flash_RW_cure_time:
	parameter.prec = 10 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Cure time");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "s");
	parameter.max = 300 ;  
	parameter.min = 0 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->RWflash[setupHeadNr].cure_time;  break;
/*******	INDEX PARAMETERS		*******/

case index_home_offset:
	parameter.prec = 1000 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Home offset");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 1500 ;  
	parameter.min = -1500 ;  
	parameter.step = 1 ;  
	parameter.def = 1017 ;  
	parameter.value = &param->idx.home_offset; break;
case index_home_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 500 ;  
	parameter.min = 10 ;  
	parameter.step = 1 ;
	parameter.def = 50 ;  
	parameter.value = &param->idx.home_vel; break;
case index_home_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 1000 ;  
	parameter.min = 10 ;  
	parameter.step = 1 ;  
	parameter.def = 40 ;
	parameter.value = &param->idx.home_acc; break;
case index_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 2500 ;  
	parameter.min = 500 ;  
	parameter.step = 1 ;  
	parameter.def = 500 ;  
	parameter.value = &param->idx.vel; break;
case index_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 15000 ;  
	parameter.min = 3000 ;  
	parameter.step = 1 ;  
	parameter.def = 3000 ;  
	parameter.value = &param->idx.acc;  break;
case index_dist:
	parameter.prec = 1000 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Distance");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 10000 ;  
	parameter.min = 8000 ;  
	parameter.step = 1 ;  
	parameter.def = 9000 ;  
	parameter.value = &param->idx.dist; break;
case index_ret_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Return velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 2500 ;  
	parameter.min = 500 ;  
	parameter.step = 1 ;  
	parameter.def = 500 ;  
	parameter.value = &param->idx.ret_vel; break;
case index_ret_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Return acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 15000 ;  
	parameter.min = 3000 ;  
	parameter.step = 1 ;  
	parameter.def = 3000 ;  
	parameter.value = &param->idx.ret_acc; break;
case index_half_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Half-index velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 1000 ;  
	parameter.min = 100 ;  
	parameter.step = 1 ;  
	parameter.def = 100 ;  
	parameter.value = &param->idx.half_vel; break;
case index_half_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Half-index acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 5000 ;  
	parameter.min = 1000 ;  
	parameter.step = 1 ;  
	parameter.def = 1000 ;  
	parameter.value = &param->idx.half_acc; break;

/*******	LIFT PARAMETERS		*******/

case lift_home_offset:
	parameter.prec = 1000 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Home offset");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 1500 ;  
	parameter.min = -1500 ;  
	parameter.step = 1 ;  
	parameter.def = 0 ;  
	parameter.value = &param->lift.home_offset; break;
case lift_home_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 500 ;  
	parameter.min = 10 ;  
	parameter.step = 1 ;  
	parameter.def = 100 ;  
	parameter.value = &param->lift.home_vel; break;
case lift_home_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Home acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 1000 ;  
	parameter.min = 10 ;  
	parameter.step = 1 ;  
	parameter.def = 40 ;
	parameter.value = &param->lift.home_acc; break;
case lift_vel:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Velocity");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM");
	parameter.max = 3000 ;  
	parameter.min = 500 ;  
	parameter.step = 1 ;  
	parameter.def = 1000 ;  
	parameter.value = &param->lift.vel; break;
case lift_acc:
	parameter.prec = 1 ;
	parameter.aut_level = 2;
	strcpy (parameter.name, "Acceleration");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "RPM/s");
	parameter.max = 19000 ;  
	parameter.min = 3000 ;  
	parameter.step = 1 ;  
	parameter.def = 3000 ;  
	parameter.value = &param->lift.acc;  break;
case lift_dist:
	parameter.prec = 1000 ;
	parameter.aut_level = 1;
	strcpy (parameter.name, "Distance");
	strcpy (parameter.descr, " ");
	strcpy (parameter.unit, "in");
	parameter.max = 2000 ;  
	parameter.min = 1000 ;  
	parameter.step = 1 ;  
	parameter.def = 1000 ;  
	parameter.value = &param->lift.dist; break;

}
}


void *machine_loop()
{
    extern unsigned int work_f;
    extern unsigned char reset_f;
    extern unsigned int tshirt_f;
    unsigned char z;
    unsigned char param = 0;

    sleep(5);    
    do
    {
	if ((work_f==0) && (reset_f==1))
	{
	    for (z = 0; z <= (mach_size-2); z++)
	    {
/*		if (key_jogup_pressed[z]) {jog_head_up(z+1);}
		if (key_jogdn_pressed[z]) {jog_head_down(z+1);}
		if (key_airll_pressed[z]) {move_slock_left(z+1); key_airll_pressed[z]=0;}
		if (key_airlr_pressed[z]) {move_slock_right(z+1); key_airlr_pressed[z]=0;}
		if (key_squ_fl_pressed[z]) {move_squ_fl(z+1); key_squ_fl_pressed[z]=0;}
		if (key_index_pressed[z]) {move_idx_rotate(IDX_BOARD); key_index_pressed[z]=0;}
		if (key_table_pressed) {move_table(IDX_BOARD); key_table_pressed=0;}
		if ((key_test_pressed[z] == 1) && (test_print_key_f == 0)) {test_print_key_f = 1; test_print(z);}
*/	    }
	}
	if ((((work_f==1)) || (end_cycle==0)) && (reset_f==1))
	{
	    end_cycle = 0;
	    if ((mode_f == 0) && (print_stage == 0)) {print_stage = 7;}
	    if (((print_finish_f == 1) || (print_test_f == 1)) && (tshirt_f == 0))
	    {
		work_f = 0;
		print_finish_f = 0;
		print_test_f = 0;
		skip_f = 1;
	    }
	    else {print_cycle();}

	    usleep(100000);
	    print_cycle();
//   		ReadDictionaryEntry(0, 0x01, 0x60FE, 0x01, &param);
//		usleep(50000);
//   		ReadDictionaryEntry(0, 0x02, 0x60FE, 0x01, &param);
//		usleep(50000);
// 		ReadDictionaryEntry(0, 0x03, 0x60FE, 0x01, &param);
//   		WriteDictionaryEntry(0, 0x01, 0x60FE, 0x01, sizeof(param), &param);
//		usleep(10000);
//		WriteDictionaryEntry(0, 0x02, 0x60FE, 0x01, sizeof(param), &param);
//		usleep(10000);
//   		WriteDictionaryEntry(0, 0x03, 0x60FE, 0x01, sizeof(param), &param);
//		usleep(10000);
	    
	}
    } while (1);
}

void set_ICU_preoperational_mode(int head_no)
{
    Send_NMT(0, head_no, &ICU_PREOPERATION_MODE);
}

void set_ICU_operational_mode(int head_no)
{
    Send_NMT(0, head_no, &ICU_OPERATION_MODE);
}

void move_lift_down_check(int head_no)
{
    extern unsigned char lift_up_pos;
    unsigned char time_elapsed = 0;
    unsigned char data_inp;
    char data_ma[20];
    char data_acc[20];


    char data1[] = "\\2\15\0";
//    char data2[] = "ACC=18000\15\0"; //bylo 5000
//    char data3[] = "MA 0 3000 1\15\0"; //bylo 1000

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.lift.acc+3000));
    sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.lift.vel+500));

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(300000);
/*
//procedura powiadamiania za pomoca inputow z drive'u
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x60fd, 0, (char *) &data_inp);
//        printf("\n8   %d\n", &data_inp);
    }while (((((data_inp & 0x02) != 0x02) & (time_elapsed != 70))));

    time_elapsed = 0;

    if ((data_inp & 0x02) != 0x02) {printMsg(_(">LIFT DOWN not completed"));}
    else {printMsg(_(">LIFT DOWN done")); lift_up_pos = 0;}
*/
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 50))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">LIFT DOWN not completed"));}
    else {printMsg(_(">LIFT DOWN done")); lift_up_pos = 0; lift_dn_pos = 1;}

// ----------------------FOR TRIDENT ONLY------------------------
/*    extern unsigned int status;

    status = read_OUT(0);
    status &= !(bLiftValve);	//bLiftValve = 0x00010000 -  00000000 00000001 00000000 00000000 (bit16 - OUT1)

    change_OUT(0, status);
*/

}

unsigned char lift_down_check(int head_no)
{
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    if (data_read[0] == '!') {printMsg(_(">LIFT DOWN done")); lift_up_pos = 0; lift_dn_pos = 1; return(1);}
    else {printMsg(_(">LIFT DOWN not completed")); return(0);}
}

void move_lift_down(int head_no)
{
    char data_ma[20];
    char data_acc[20];

    char data1[] = "\\2\15\0";
//    char data2[] = "ACC=18000\15\0"; //bylo 5000
//    char data3[] = "MA 0 3000 1\15\0"; //bylo 1000

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.lift.acc+3000));
    sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.lift.vel+500));

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA

    lift_up_pos = 0;
    lift_dn_pos = 0;
}

void move_lift_up_check(int head_no)
{
    extern unsigned char lift_up_pos;
    unsigned char time_elapsed = 0;
    unsigned char data_inp;
    int lift_dist_temp;

    char data1[] = "\\2\15\0";
//    char data2[] = "ACC=18000\15\0"; //bylo 5000
//    char data3[] = "MA 713000 3000 1\15\0"; //bylo 1000

    char data_ma[20];
    char data_acc[20];

    lift_dist_temp = (int)machine_param.lift.dist;
    lift_dist_temp = ((lift_dist_temp * 476) + 475604);

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.lift.acc+3000));
    sprintf(data_ma, "MA %d %d 1\15\0", lift_dist_temp, (machine_param.lift.vel+500));

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(300000);
    lift_up_pos = 0;
    lift_dn_pos = 0;
/*
//procedura powiadamiania za pomoca inputow z drive'u
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x60fd, 0, (char *) &data_inp);
//        printf("\n8   %d\n", &data_inp);
    }while (((((data_inp & 0x02) != 0x02) & (time_elapsed != 70))));

    time_elapsed = 0;

    if ((data_inp & 0x02) != 0x02) {printMsg(_(">LIFT UP not completed"));}
    else {printMsg(_(">LIFT UP done")); lift_up_pos = 1;}
*/
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 50))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">LIFT UP not completed"));}
    else {printMsg(_(">LIFT UP done")); lift_up_pos = 1; lift_dn_pos = 0;}

// ---------------------FOR TRIDENT ONLY-------------------------
/*    unsigned int status;

    status = read_OUT(0);
    status |= bLiftValve;	//bLiftValve = 0x00010000 -  00000000 00000001 00000000 00000000 (bit16 - OUT1)

    change_OUT(0, status);
*/
}

unsigned char lift_up_check(int head_no)
{
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    if (data_read[0] == '!') {printMsg(_(">LIFT UP done")); lift_up_pos = 1; lift_dn_pos = 0; return(1);}
    else {printMsg(_(">LIFT UP not completed")); lift_up_pos = 0; return(0);}
}

void move_lift_up(int head_no)
{
    char data1[] = "\\2\15\0";
//    char data2[] = "ACC=18000\15\0"; //bylo 5000
//    char data3[] = "MA 713000 3000 1\15\0"; //bylo 1000
    int lift_dist_temp;

    char data_ma[20];
    char data_acc[20];

    lift_dist_temp = (int)machine_param.lift.dist;
    lift_dist_temp = ((lift_dist_temp * 476) + 475604);

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.lift.acc+3000));
    sprintf(data_ma, "MA %d %d 1\15\0", lift_dist_temp, (machine_param.lift.vel+500));

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    lift_up_pos = 0;
    lift_dn_pos = 0;
}

void move_idx_lock(void)
{
    unsigned int status;

    status = read_OUT(0);
    status |= bIdxValve;	//bIdxValve = 0x00020000 -  00000000 00000010 00000000 00000000 (bit17 - OUT2)
    usleep(1000);
    change_OUT(0, status);
}

void move_idx_unlock(void)
{
    unsigned int status;

    status = read_OUT(0);
    status &= (~bIdxValve);	//bIdxValve = 0x00020000 -  00000000 00000010 00000000 00000000 (bit17 - OUT2)
    usleep(1000);
    change_OUT(0, status);
}

void move_idx_posA_check(int head_no)  //move to position near home position
{
    extern unsigned char half_idx_f;
    extern unsigned char idx_posA;
    unsigned char time_elapsed = 0;
    unsigned char data_inp;

    char data1[] = "\\1\15\0";
//    char data2[] = "ACC=5500\15\0";
//    char data3[] = "MA 0 1000\15\0";	//Nie zmieniac - offset dla INDEX  !!!!!!!

    char data_ma[20];
    char data_acc[20];

    if (half_idx_f == 0)
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.acc+3000));
	sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.vel+500));
    }
    else
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.half_acc+1000));
	sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.half_vel+100));
    }
    

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(400000);

/*
//procedura powiadamiania za pomoca inputow z drive'u
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x60fd, 0, (char *) &data_inp);
//        printf("\n8   %d\n", &data_inp);
    }while (((((data_inp & 0x01) != 0x01) & (time_elapsed != 70))));

    time_elapsed = 0;

    if ((data_inp & 0x01) != 0x01) {printMsg(_(">IDX-A not completed"));}
    else {printMsg(_(">IDX-A done")); idx_posA = 1;}
*/

    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 50))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">IDX-A not completed")); idx_posA = 0;}
    else {printMsg(_(">IDX-A done")); idx_posA = 1; idx_posB = 0; half_idx_f = 0;}

}

unsigned char idx_posA_check(int head_no)
{
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    if (data_read[0] == '!') {printMsg(_(">IDX POS A done")); idx_posA = 1; idx_posB = 0; return(1);}
    else {printMsg(_(">IDX POS A not completed")); idx_posA = 0; return(0);}
}

void move_idx_posA(int head_no)  //move to position near home position without pos checking
{
    extern unsigned char half_idx_f;
    char data1[] = "\\1\15\0";
    char data_ma[20];
    char data_acc[20];


    if (half_idx_f == 0)
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.acc+3000));
	sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.vel+500));
    }
    else
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.half_acc+1000));
	sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.half_vel+100));
    }

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    idx_posA = 0;
    idx_posB = 0;
}

void move_idx_posB_check(int head_no)  //move to postion away from home position with pos checking
{
    extern unsigned char half_idx_f;
    extern unsigned char idx_posA;
    unsigned char time_elapsed = 0;
    int idx_dist_temp;
    unsigned char data_inp;

    char data1[] = "\\1\15\0";
//    char data2[] = "ACC=5500\15\0";
//    char data3[] = "MA -936300 1000\15\0";	//Nie zmieniac - distance dla INDEX  !!!!!!!

    char data_ma[20];
    char data_acc[20];

    idx_dist_temp = (int)machine_param.idx.dist;
    idx_dist_temp = -((idx_dist_temp * 104) + 832304);

    if (half_idx_f == 0)
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.acc+3000));
	sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.vel+500));
    }
    else
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.half_acc+1000));
	sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.half_vel+100));
    }
    

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(400000);
    idx_posA = 0;
    idx_posB = 0;

/*
//procedura powiadamiania za pomoca outputow z drive'u
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x60fd, 0, (char *) &data_inp);
//        printf("\n8   %d\n", &data_inp);
    }while (((((data_inp & 0x01) != 0x01) & (time_elapsed != 70))));

    time_elapsed = 0;

    if ((data_inp & 0x01) != 0x01) {printMsg(_(">IDX-B not completed"));}
    else {printMsg(_(">IDX-B done")); idx_posA = 0;}
*/

    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 50))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">IDX-B not completed")); idx_posB = 0;}
    else {printMsg(_(">IDX-B done")); idx_posA = 0; idx_posB = 1; half_idx_f = 0;}

}

unsigned char idx_posB_check(int head_no)
{

    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    if (data_read[0] == '!') {printMsg(_(">IDX POS B done")); idx_posB = 1; idx_posA = 0; return(1);}
    else {printMsg(_(">IDX POS A not completed")); return(0); idx_posB = 0;}
}

void move_idx_posB(int head_no)  //move to postion away from home position without pos checking
{
    extern unsigned char half_idx_f;
    int idx_dist_temp;

    char data1[] = "\\1\15\0";
    char data_ma[20];
    char data_acc[20];

    idx_dist_temp = (int)machine_param.idx.dist;
    idx_dist_temp = -((idx_dist_temp * 104) + 832304);

    if (half_idx_f == 0)
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.acc+3000));
	sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.vel+500));
    }
    else
    {
	sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.half_acc+1000));
	sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.half_vel+100));
    }

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    idx_posA = 0;
    idx_posB = 0;
}


void move_idx_return_check(int head_no)  //move to postion when lift is up
{
    extern unsigned char idx_posA;
    unsigned char time_elapsed = 0;
    int idx_dist_temp;
    unsigned char data_inp;

    char data1[] = "\\1\15\0";

    char data_ma[20];
    char data_acc[20];

    switch (idx_dir_f)
    {
	case 0:
	{
	    sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.ret_acc+3000));
	    sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.ret_vel+500));
	    break;
	}
        case 1:
	{
    	    idx_dist_temp = (int)machine_param.idx.dist;
	    idx_dist_temp = -((idx_dist_temp * 104) + 832304);

	    sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.ret_acc+3000));
	    sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.ret_vel+500));
	    break;
	}
    }
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(400000);
    idx_posA = 0;
    idx_posB = 0;
/*
//procedura powiadamiania za pomoca outputow z drive'u
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x60fd, 0, (char *) &data_inp);
//        printf("\n8   %d\n", &data_inp);
    }while (((((data_inp & 0x01) != 0x01) & (time_elapsed != 70))));

    time_elapsed = 0;

    if ((data_inp & 0x01) != 0x01) {printMsg(_(">IDX-B not completed"));}
    else {printMsg(_(">IDX-B done")); idx_posA = 0;}
*/

    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
	ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//     	printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 50))));

    time_elapsed = 0;

    switch (idx_dir_f)
    {
	case 0:
	{
	    if (data_read[0] != '!') {printMsg(_(">IDX-A not completed")); idx_posA = 0;}
	    else {printMsg(_(">IDX-A done")); idx_posA = 1; idx_posB = 0; half_idx_f = 0;}
	    break;
	}
        case 1:
	{
	    if (data_read[0] != '!') {printMsg(_(">IDX-B not completed")); idx_posB = 0;}
	    else {printMsg(_(">IDX-B done")); idx_posB = 1; idx_posA = 0; half_idx_f = 0;}
	    break;
	}
    }
}

void move_idx_return(int head_no)  //move to postion when lift is up
{
    int idx_dist_temp;

    char data1[] = "\\1\15\0";

    char data_ma[20];
    char data_acc[20];

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.ret_acc+3000));

    switch (idx_dir_f)
    {
	case 0:
	{
	    sprintf(data_ma, "MA 0 %d 1\15\0", (machine_param.idx.ret_vel+500));
	    break;
	}
        case 1:
	{
    	    idx_dist_temp = (int)machine_param.idx.dist;
	    idx_dist_temp = -((idx_dist_temp * 104) + 832304);

	    sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.ret_vel+500));
	    break;
	}
    }
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    idx_posA = 0;
    idx_posB = 0;
}

void move_idx_posAB(int head_no)  //move to medium position (HALF INDEX)
{
    unsigned char time_elapsed = 0;
    int idx_dist_temp;

    char data1[] = "\\1\15\0";
//    char data2[] = "ACC=5500\15\0";
//    char data3[] = "MA -468150 1000\15\0";

    char data_ma[20];
    char data_acc[20];

    idx_dist_temp = (int)machine_param.idx.dist;
    idx_dist_temp = (-((idx_dist_temp * 104) + 832304))/2;

    sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.acc+3000));
    sprintf(data_ma, "MA %d %d 1\15\0", idx_dist_temp, (machine_param.idx.half_vel+100));

//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA
    usleep(400000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    idx_posA = 0;
    idx_posB = 0;
    time_elapsed = 0;
    do
    {
	usleep(100000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 40))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">H-IDX not completed"));}
    else {printMsg(_(">H-IDX done")); half_idx_f = 1;}
}

void move_idx_right(int head_no)
{
switch (half_idx_f)
{
    case 0:
    {
	if ((idx_posA == 1) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_lift_down_check(IDX_BOARD);}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_up_pos == 1) && (lift_dn_pos == 0)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 1) && (idx_posB == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    break;
	}
	else
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_lift_up_check(IDX_BOARD);}
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posA_check(IDX_BOARD);} else {break;}
	    if ((idx_posB == 0) && (idx_posA == 1)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_up_pos == 1) && (lift_dn_pos == 0)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 1) && (idx_posB == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    break;
	}

    }
    case 1:
    {
	move_hidx_right(IDX_BOARD);
	break;
    }
}
    tshirt_f <<= 1;
}

void move_idx_left(int head_no)
{
extern unsigned char half_idx_f;

switch (half_idx_f)
{
    case 0:
    {
	if ((idx_posA == 1) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_lift_up_check(IDX_BOARD);}
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posB_check(IDX_BOARD);} else {break;}
	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    if ((lift_up_pos == 0) && (lift_dn_pos == 1)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 1) && (idx_posB == 0)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    break;
	}
	else
	{
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_lift_down_check(IDX_BOARD);}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posB == 0) && (idx_posA == 1)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_up_pos == 1) && (lift_dn_pos == 0)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 0) && (idx_posB == 1)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    break;
	}

    }
    case 1:
    {
	move_hidx_left(IDX_BOARD);
	break;
    }
}
    tshirt_f >>= 1;
}

void move_hidx_right(int head_no)
{
extern unsigned char half_idx_f;

switch (half_idx_f)
{
    case 0:
    {
	if ((idx_posA == 1) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_lift_down_check(IDX_BOARD);}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posAB(IDX_BOARD);} else {break;}
	    half_idx_f = 1;
	    break;
	}
	if ((idx_posA == 0) && (idx_posB == 1))
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_lift_up_check(IDX_BOARD);}
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posA_check(IDX_BOARD);} else {break;}
	    if ((idx_posB == 0) && (idx_posA == 1)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    if ((lift_up_pos == 0) && (lift_dn_pos == 1)) {move_idx_posAB(IDX_BOARD);} else {break;}
	    half_idx_f = 1;
	    break;
	}
    }
    case 1:
    {
	if ((idx_posA == 0) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 1) && (idx_posB == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    half_idx_f = 0;
	    tshirt_f <<= 1;
	    break;
	}
    }
}
}

void move_hidx_left(int head_no)
{
extern unsigned char half_idx_f;

switch (half_idx_f)
{
    case 0:
    {
	if ((idx_posA == 1) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_lift_up_check(IDX_BOARD);}
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posB_check(IDX_BOARD);} else {break;}
	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posAB(IDX_BOARD);} else {break;}
	    half_idx_f = 1;
	    break;
	}
	if ((idx_posA == 0) && (idx_posB == 1))
	{
	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_lift_down_check(IDX_BOARD);}
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posAB(IDX_BOARD);} else {break;}
	    half_idx_f = 1;
	    break;
	}
    }
    case 1:
    {
	if ((idx_posA == 0) && (idx_posB == 0))
	{
	    if ((lift_dn_pos == 1) && (lift_up_pos == 0)) {move_idx_posA_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 1) && (idx_posB == 0)) {move_lift_up_check(IDX_BOARD);} else {break;}
//	    if ((lift_dn_pos == 0) && (lift_up_pos == 1)) {move_idx_posB_check(IDX_BOARD);} else {break;}
//	    if ((idx_posA == 0) && (idx_posB == 1)) {move_lift_down_check(IDX_BOARD);} else {break;}
	    half_idx_f = 0;
	    tshirt_f >>= 1;
	    break;
	}
    }
}

}

void move_idx_rotate(int head_no) //obsluga z klawiaturki
{
    unsigned int key_press_f;

    usleep(500000); //poczekaj i sprawdz czy klawisz zwolniony, jezeli zwolniony to rotate_right, jezeli nie, to rotate_left
    ReadDictionaryEntry(0, head_no, 0x2001, 0, (char *) &data_read);
    key_press_f = data_read;
    if ((key_press_f & 0x00000400) == 0x00000400) {move_idx_left(head_no);}
    else {move_idx_right(head_no);}
}

void move_table(int head_no)
{
    if (lift_dn_pos == 1) {move_lift_up_check(head_no);}
    else {if (lift_up_pos == 1) {move_lift_down_check(head_no);}}
}

void move_head_posA(int head_no)  //move to outside position (front position)
{
//disable drive
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
//change OPMODE to Profile Position Mode
//    WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_PTP), &ICU_OPMODE_PTP);
//set profile velocity
    change_VEL(head_no, ((machine_param.head[head_no-1].flood_vel +1) * 44));
//switch on drive
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
//enable drive with absolute move
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
//set position and run
    change_POS(head_no,(-(((int)machine_param.head[head_no-1].front_pos) * 476)));
}

void move_head_posB(int head_no)  //move to inside position (rear position)
{
//disable drive
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
//change OPMODE to Profile Position Mode
//    WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_PTP), &ICU_OPMODE_PTP);
//set profile velocity
    change_VEL(head_no, ((machine_param.head[head_no-1].print_vel +1) * 44));
//switch on drive
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
//enable drive with absolute move
//    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
//set position and run
    change_POS(head_no,(-(((int)machine_param.head[head_no-1].rear_pos) * 476)));
}

unsigned char check_head_pos(int head_no)
{
    unsigned short data_read;

    ReadDictionaryEntry(0, head_no, 0x6041, 0, (char *) &data_read);
    if (data_read & ICU_STAT_MOVE_DONE) {return(1);}
    else {return(0);}
}

void jog_head_up(int head_no)
{

    short jog_vel_temp;
    int actual_pos;

    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    actual_pos = data_read;

    if (actual_pos > (-(machine_param.head[head_no-1].rear_pos * 476))) //sprawdz czy pozycja miesci sie w granicach front-rear pos, jezeli tak to wykonaj
    {
	if (head_jog_f[head_no-1] == 0) //jezeli motor nie jest w ruchu to wykonaj
	{
	    //disable drive
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
	    //change OPMODE to Velocity Mode
	    WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_JOG);
	    //switch on drive
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
	    //enable drive with absolute move
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
	    //set velocity and run
	    jog_vel_temp = -((machine_param.head[head_no-1].jog_vel +1) * 44);
	    WriteDictionaryEntry(0, head_no, 0x6042, 0x00, sizeof(jog_vel_temp), &jog_vel_temp);
	    head_jog_f[head_no-1] = 1;
	}
	else //jezeli motor w ruchu to sprawdz czy klawisz jest jeszcze nacisniety, jezeli nie to zatrzymaj motor i przelacz w PTP
	{
	    ReadDictionaryEntry(0, head_no, 0x2001, 0, (char *) &data_read);
	    actual_pos = data_read;

	    if ((actual_pos & 0x00000100) != 0x00000100)
	    {
		//disable drive
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
		//change OPMODE to Position Mode
		WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_PTP);
		//switch on drive
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
		//enable drive with absolute move
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);

	        key_jogdn_pressed[head_no-1] = 0;
		head_jog_f[head_no-1] = 0;
	    }
	}
    }
    else //jezeli pozycja graniczna osiagnieta zatrzymaj motor i przelacz w PTP
    {
	//disable drive
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
	//change OPMODE to Position Mode
	WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_PTP);
	//switch on drive
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
	//enable drive with absolute move
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);

	key_jogdn_pressed[head_no-1] = 0;
	head_jog_f[head_no-1] = 0;
    }
}

void jog_head_down(int head_no)
{
    short jog_vel_temp;
    int actual_pos;

    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
    actual_pos = data_read;

    if (actual_pos < (-(machine_param.head[head_no-1].front_pos * 476))) //sprawdz czy pozycja miesci sie w granicach front-rear pos, jezeli tak to wykonaj
    {
	if (head_jog_f[head_no-1] == 0) //jezeli motor nie jest w ruchu to wykonaj
	{
	    //disable drive
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
	    //change OPMODE to Velocity Mode
	    WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_JOG);
	    //switch on drive
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
	    //enable drive with absolute move
	    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
	    //set velocity and run
	    jog_vel_temp = ((machine_param.head[head_no-1].jog_vel +1) * 44);
	    WriteDictionaryEntry(0, head_no, 0x6042, 0x00, sizeof(jog_vel_temp), &jog_vel_temp);
	    head_jog_f[head_no-1] = 1;
	}
	else //jezeli motor w ruchu to sprawdz czy klawisz jest jeszcze nacisniety, jezeli nie to zatrzymaj motor i przelacz w PTP
	{
	    ReadDictionaryEntry(0, head_no, 0x2001, 0, (char *) &data_read);
	    actual_pos = data_read;

	    if ((actual_pos & 0x00010000) != 0x00010000)
	    {
		//disable drive
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
		//change OPMODE to Position Mode
		WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_PTP);
		//switch on drive
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
		//enable drive with absolute move
		WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);

	        key_jogdn_pressed[head_no-1] = 0;
		head_jog_f[head_no-1] = 0;
	    }
	}
    }
    else //jezeli pozycja graniczna osiagnieta zatrzymaj motor i przelacz w PTP
    {
	//disable drive
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
	//change OPMODE to Position Mode
	WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_JOG), &ICU_OPMODE_PTP);
	//switch on drive
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
	//enable drive with absolute move
	WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);

	key_jogdn_pressed[head_no-1] = 0;
	head_jog_f[head_no-1] = 0;
    }
}

void enable_head(int head_no)
{
//change OPMODE to Profile Position Mode
    WriteDictionaryEntry(0, head_no, 0x6060, 0x00, sizeof(ICU_OPMODE_PTP), &ICU_OPMODE_PTP);
//switch on drive
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
//enable drive with absolute move
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
}

void disable_head(int head_no)
{
//disable drive
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
}

void move_squ_fl(int head_no)
{
    unsigned int status;

//move squeegee
    if (key_set_pressed[head_no-1])
    {
	status = read_OUT(head_no);
	status ^= bSqueeValve;
	change_OUT(head_no, status);
    }
//move flood
    else
    {
	status = read_OUT(head_no);
	status ^= bFloodValve;
	change_OUT(head_no, status);
    }
}

void move_slock_left(int head_no)
{
    unsigned int status;

    status = read_OUT(head_no);
    status ^= bScreenL;
    usleep(5000);
    change_OUT(head_no, status);
}

void move_slock_right(int head_no)
{
    unsigned int status;

    status = read_OUT(head_no);
    status ^= bScreenR;
    usleep(5000);
    change_OUT(head_no, status);
}

void move_flood_down(int head_no)
{
/*    unsigned int status;

    status = read_OUT(head_no);
    status |= bFloodValve;	//bFloodValve = 0x00020000 -  00000000 00000100 00000000 00000000 (bit17 - OUT2)
    usleep(5000);
    change_OUT(head_no, status);
*/    outputs[head_no-1] |= bFloodValve;	//bFloodValve = 0x00020000 -  00000000 00000100 00000000 00000000 (bit17 - OUT2)
    change_OUT(head_no, outputs[head_no-1]);
    
}

void move_flood_up(int head_no)
{
/*    unsigned int status;

    status = read_OUT(head_no);
    status &= (~bFloodValve);
    usleep(5000);
    change_OUT(head_no, status);
*/    outputs[head_no-1] &= (~bFloodValve);
    change_OUT(head_no, outputs[head_no-1]);
}

void move_squee_down(int head_no)
{
/*    unsigned int status;

    status = read_OUT(head_no);
    status |= bSqueeValve;	//bSqueeValve = 0x00010000  -  00000000 00000010 00000000 00000000 (bit16 - OUT1)
    usleep(5000);
    change_OUT(head_no, status);
*/    outputs[head_no-1] |= bSqueeValve;	//bSqueeValve = 0x00010000  -  00000000 00000010 00000000 00000000 (bit16 - OUT1)
    change_OUT(head_no, outputs[head_no-1]);
}

void move_squee_up(int head_no)
{
/*    unsigned int status;

    status = read_OUT(head_no);
    status &= (~bSqueeValve);
    usleep(5000);
    change_OUT(head_no, status);
*/    outputs[head_no-1] &= (~bSqueeValve);
    change_OUT(head_no, outputs[head_no-1]);
}

void buzzer_on(unsigned long buzz_time)
{
    unsigned int status;

    status = read_OUT(1);
    status |= bBuzzer;
    change_OUT(1, status);	//Buzzer on the first head
    usleep(1000);
    usleep(buzz_time);

    status &= (~bBuzzer);
    change_OUT(1, status);
}

void switch_LED(unsigned char state, int head_no)	//state == 0 -> LED off, state == 1 -> LED on
{
    unsigned int status;

    status = read_OUT(head_no);
    usleep(1000);
    switch (state)
    {
	case 0:	status &= (~bSafetyLED);
	case 1: status |= bSafetyLED;
    }
    change_OUT(head_no, status);
}

void machine_error()
{
    reset_f = 0;
    work_f = 0;
}

void machine_stop()
{
    unsigned char head_no;

    char data1[] = "\\1\15\0"; //disable indexer
    char data2[]= "K\15\0";
    char data3[] = "\\2\15\0"; //disable lift
    char data4[]= "K\15\0";

    WriteDictionaryEntry(0, IDX_BOARD, 0x2005, 0, sizeof(data1), &data1); //ADDRESS=1 --> INDEXER
    usleep(50000);

    WriteDictionaryEntry(0, IDX_BOARD, 0x2005, 0, sizeof(data2), &data2); //DISABLE INDEXER DRIVE
    usleep(50000);

    WriteDictionaryEntry(0, IDX_BOARD, 0x2005, 0, sizeof(data3), &data3); //ADDRESS=2 --> LIFT
    usleep(50000);

    WriteDictionaryEntry(0, IDX_BOARD, 0x2005, 0, sizeof(data4), &data4); //DISABLE LIFT DRIVE
    usleep(50000);

    for (head_no = 1; head_no < (machine_size-2); head_no++)
    {
	WriteDictionaryEntry(0, head_no, 0x6040, 0, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE); //DISABLE HEAD
    }
}

void head_home(int head_no)
{
//disable drive
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_DISABLE), &ICU_CTRL_DISABLE);
//    usleep(1000);
//change homing velocity
    change_H_VEL(head_no, ((machine_param.head[head_no-1].home_vel + 1) * 44));
//    usleep(1000);
//change homing offset (must be lees than 0)
    change_H_OFF(head_no, (-((machine_param.head[head_no-1].home_offset) * 476)));
//    usleep(1000);
//switch on drive
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_SWITCH_ON), &ICU_CTRL_SWITCH_ON);
//    usleep(1000);
//enable drive
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_ENABLE), &ICU_CTRL_ENABLE);
//    usleep(1000);
//move head to home
    WriteDictionaryEntry(0, head_no, 0x6040, 0x00, sizeof(ICU_CTRL_HOME), &ICU_CTRL_HOME);
//    usleep(1000);
}

unsigned char check_head_home(int head_no)
{
    unsigned short data_read;

    ReadDictionaryEntry(0, head_no, 0x6041, 0, (char *) &data_read);
    if (data_read & ICU_STAT_HOME_OK) {return(1);}
    else {return(0);}
}

void lift_home(int head_no)
{

    extern unsigned char lift_up_pos;
    unsigned char home_part = 0;
    unsigned char time_elapsed = 0;
    char data1[] = "\\2\15\0";
    char data13[]= "PROMPT=0\15\0";
    char data11[]= "ECHO=0\15\0";
    char data12[]= "K\15\0";
    char data14[]= "O1MODE=6\15\0";
    char data2[] = "OPMODE=8\15\0";
    char data3[] = "HOMETYPE=6\15\0";
//    char data4[] = "HOMESPD=-100\15\0";//bylo -50
//    char data5[] = "ACC=40\15\0";
    char data51[]= "EN\15\0";
    char data6[] = "MH 1\15\0";
//    char data7[] = "MA -150000 50 1\15\0";	//Nie zmieniac - offset dla LIFT  !!!!!!!
    char data8[] = "HOMETYPE=3\15\0";
    char data9[] = "MH 1\15\0";
    char data10[]= "HOMESTATE\15\0";
    char data_vel[20];
    char data_ma[20];
    char data_acc[20];
    int home_offset_temp;
    
    home_offset_temp = (int)machine_param.lift.home_offset;
    home_offset_temp = ((home_offset_temp)-1500)*476; //  475604counts/1cal

    sprintf(data_vel, "HOMESPD=%d\15\0", (-(machine_param.lift.home_vel+10))); //zamiast data4
    sprintf(data_acc, "ACC=%d\15\0", (machine_param.lift.home_acc+10)); //zamiast data5
    sprintf(data_ma, "MA %d %d 1\15\0", home_offset_temp, (machine_param.lift.home_vel+10)); //zamiast data7

    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS=2 --> LIFT
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n1   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data13), &data13); //PROMPT=0
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n1   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data11), &data11); //ECHO=0
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data12), &data12); //K
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data14), &data14); //O1MODE=6 -> OUTPUT MOTION COMPLETE
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data2), &data2); //OPMODE=8 --> POSITION MODE
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n3   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data3), &data3); //HOMETYPE=6
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n4   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_vel), &data_vel); //HOMESPD=50
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n5   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC=-50
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n6   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data51), &data51); //EN
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n7   %s\n", &data_read);

//moving home
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data6), &data6); //MH
    usleep(3000000);

    time_elapsed = 0;
    do
    {
	usleep(500000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 10))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">MH not completed")); home_part=0;}
    else {printMsg(_(">MH done")); home_part=1;}

//moving PTP
    if (home_part == 1)
    {
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA  --> HOME OFFSET
	usleep(1000000);

        do
        {
    	    usleep(500000);
	    ++time_elapsed;
    	    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    	    printf("\n8   %s\n", &data_read);
        }while ((((data_read[0] != '!') & (time_elapsed != 10))));

	time_elapsed = 0;

	if (data_read[0] != '!') {printMsg(_(">MA not completed")); home_part=0;}
	else {printMsg(_(">MA done")); home_part=1;}
    }

//moving home --> set PFB=0
    if (home_part == 1)
    {
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data8), &data8); //HOMETYPE=3
        usleep(50000);
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data9), &data9); //MH  --> SET PFB=0 WITHOUT MOVING

        do
        {
    	    usleep(500000);
	    ++time_elapsed;
    	    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    	    printf("\n8   %s\n", &data_read);
        }while ((((data_read[0] != '!') & (time_elapsed != 10))));

	time_elapsed = 0;

	if (data_read[0] != '!') {printMsg(_(">MH not completed")); home_part=0; lift_homing = 0;}
	else {printMsg(_(">MH done, PFB=0")); home_part=1; lift_up_pos = 0; lift_dn_pos = 1; lift_homing = 1;}
    }
}


void idx_home(int head_no)
{
    extern unsigned char idx_posA;
    int home_offset_temp;
    unsigned char home_part = 0;
    unsigned char time_elapsed = 0;
    char data1[] = "\\1\15\0";
    char data13[]= "PROMPT=0\15\0";
    char data11[]= "ECHO=0\15\0";
    char data12[]= "K\15\0";
    char data14[]= "O1MODE=6\15\0";
    char data2[] = "OPMODE=8\15\0";
    char data3[] = "HOMETYPE=6\15\0";
//    char data4[] = "HOMESPD=50\15\0";
//    char data5[] = "ACC=40\15\0";
    char data51[]= "EN\15\0";
    char data6[] = "MH 1\15\0";
//    char data7[] = "MA -50300 50 1\15\0";	//Nie zmieniac - offset dla INDEX  !!!!!!!
    char data8[] = "HOMETYPE=3\15\0";
    char data9[] = "MH 1\15\0";
    char data10[]= "HOMESTATE\15\0";

    char data_vel[20];
    char data_ma[20];
    char data_acc[20];

    home_offset_temp = (int)machine_param.idx.home_offset;
    home_offset_temp = -(((home_offset_temp)-1500)*104); //  104038counts/1cal

    sprintf(data_vel, "HOMESPD=%d\15\0", (machine_param.idx.home_vel+10)); //zamiast data4
    sprintf(data_acc, "ACC=%d\15\0", (machine_param.idx.home_acc+10)); //zamiast data5
    sprintf(data_ma, "MA %d %d 1\15\0", home_offset_temp, (machine_param.idx.home_vel+10)); //zamiast data7

    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data1), &data1); //ADDRESS=1 --> INDEXER
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n1   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data13), &data13); //PROMPT=0
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n1   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data11), &data11); //ECHO=0
    usleep(50000);
    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data12), &data12); //K
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data14), &data14); //OUTPUT -> MOTION COMPLETE
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n2   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data2), &data2); //OPMODE=8 --> POSITION MODE
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n3   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data3), &data3); //HOMETYPE=6
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n4   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_vel), &data_vel); //HOMESPD=50
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n5   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_acc), &data_acc); //ACC=50
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n6   %s\n", &data_read);

    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data51), &data51); //EN
    usleep(50000);
//    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    printf("\n7   %s\n", &data_read);

//moving home
    WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data6), &data6); //MH
    usleep(3000000);

    time_elapsed = 0;
    do
    {
	usleep(500000);
	++time_elapsed;
        ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//        printf("\n8   %s\n", &data_read);
    }while ((((data_read[0] != '!') & (time_elapsed != 40))));

    time_elapsed = 0;

    if (data_read[0] != '!') {printMsg(_(">MH not completed")); home_part=0;}
    else {printMsg(_(">MH done")); home_part=1;}

//moving PTP
    if (home_part == 1)
    {
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data_ma), &data_ma); //MA  --> HOME OFFSET
	usleep(1000000);

        do
        {
    	    usleep(500000);
	    ++time_elapsed;
    	    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    	    printf("\n8   %s\n", &data_read);
        }while ((((data_read[0] != '!') & (time_elapsed != 10))));

	time_elapsed = 0;

	if (data_read[0] != '!') {printMsg(_(">MA not completed")); home_part=0;}
	else {printMsg(_(">MA done")); home_part=1;}
    }

//moving home --> set PFB=0
    if (home_part == 1)
    {
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data8), &data8); //HOMETYPE=3
        usleep(50000);
        WriteDictionaryEntry(0, head_no, 0x2005, 0, sizeof(data9), &data9); //MH  --> SET PFB=0 WITHOUT MOVING

        do
        {
    	    usleep(500000);
	    ++time_elapsed;
    	    ReadDictionaryEntry(0, head_no, 0x2006, 0, (char *) &data_read);
//    	    printf("\n8   %s\n", &data_read);
        }while ((((data_read[0] != '!') & (time_elapsed != 10))));

	time_elapsed = 0;

	if (data_read[0] != '!') {printMsg(_(">MH not completed")); home_part=0; idx_homing = 0;}
	else {printMsg(_(">MH done, PFB=0")); home_part=1; idx_posA = 1; idx_posB = 0; idx_homing = 1; half_idx_f = 0;}
    }
}

void start_heat(int head_no, int output)
{
    unsigned int status;

    status = read_OUT(head_no);

    switch (output)
    {
	case 1:	{status |= bFlash1; break;}
	case 2:	{status |= bFlash2; break;}
	case 3:	{status |= bFlash3; break;}
	case 4:	{status |= bFlash4; break;}
    }
    change_OUT(head_no, status);
}

void stop_heat(int head_no, int output)
{
    unsigned int status;

    status = read_OUT(head_no);

    switch (output)
    {
	case 1:	{status &= (~bFlash1); break;}
	case 2:	{status &= (~bFlash2); break;}
	case 3:	{status &= (~bFlash3); break;}
	case 4:	{status &= (~bFlash4); break;}
    }

    change_OUT(head_no, status);
}

unsigned short read_temp(int head_no)
{
    unsigned short actual_temp;

    actual_temp = read_analog(head_no) - 806;	//offset 660mV (1bit = 1.220703125mV, 9.6mV/1F)
    actual_temp = (actual_temp * 1.2207)/9.6;
    return(actual_temp);
}

void *heat_function()
{
extern unsigned char print_stage;
unsigned char z;
unsigned int x;
extern unsigned char heat_on_f;
unsigned int timer;
unsigned int stby_timer;
unsigned int stby_pow_timer;
extern unsigned int heat_off_f;
extern unsigned int stby_heat_off_f;
extern unsigned char bheat_off;

    if ((work_f == 1) | (test_print_key_f == 1))
    {
	do
	{
	    switch (print_stage)
	    {
		case 6:
		{
		    if (heat_on_f != 1)
		    {
			x = 0x01;
			for (z = 1; z <= (mach_size-2); z++)
			{
	    		    if (en_head_f & tshirt_f & ATflash_f & x)
			    {
				if (machine_param.ATflash[z-1].preheat_f == 1)
				{
				    start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f);
				}
			    }
			    x <<= 1;
			}
			heat_on_f = 1;
		    }
		}
		case 20:
		{
		    if (heat_on_f != 2)
		    {
			x = 0x01;
			for (z = 1; z <= (mach_size-2); z++)
			{
	    		    if (en_head_f & tshirt_f & ATflash_f & x)
			    {
				start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f);
//				read_temp(machine_param.ATflash[z-1].socket_f);
			    }
	    		    if (en_head_f & tshirt_f & RWflash_f & x)
			    {
				start_heat(IDX_BOARD, machine_param.RWflash[z-1].socket_f);
			    }
			    x <<= 1;
			}
			heat_on_f = 2;
			timer = 0;
			stby_timer = 0;
		    }
		}
	    }
		usleep(100000);
		if ((bheat_off == 0) & (heat_on_f == 2))
		{
		    usleep(100000);
    		    timer++;
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & tshirt_f & ATflash_f & x & (~heat_off_f))
			{
			    if ((machine_param.ATflash[z-1].cure_time == timer) | (machine_param.ATflash[z-1].temp + 32 >= read_temp(machine_param.ATflash[z-1].socket_f)))
			    {
				stop_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f);
				heat_off_f |= x;
			    }
			}
	    		if (en_head_f & tshirt_f & RWflash_f & x & (~heat_off_f))
			{
			    if (machine_param.RWflash[z-1].cure_time == timer)
			    {
				stop_heat(IDX_BOARD, machine_param.RWflash[z-1].socket_f);
				heat_off_f |= x;
			    }
			}
			x <<= 1;
		    }
		    if (heat_off_f == (en_head_f & tshirt_f & ATflash_f & RWflash_f)) {bheat_off = 1; heat_off_f = 0;}
		    heat_on_f = 2;
		}
		if (bheat_off == 1)
		{
		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & tshirt_f & ATflash_f & x & (~stby_heat_off_f))
			{
			    if ((machine_param.ATflash[z-1].stby_time * 10) == stby_timer) {stop_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f); stby_heat_off_f |= x;}
			}
			x <<= 1;
		    }

		    x = 0x01;
		    for (z = 1; z <= (mach_size-2); z++)
		    {
	    		if (en_head_f & tshirt_f & ATflash_f & x & (~stby_heat_off_f))
			{
			    if ((machine_param.ATflash[z-1].stby_power) == stby_pow_timer) {stop_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f); stby_heat_off_f |= x;}
			}
			x <<= 1;
		    }

		    stby_timer++;
		    stby_pow_timer++; //odlicza od 0 do 20 i znowu od 0 do 20 --> do regulacji standby power

		    if (stby_pow_timer == 21)
		    {
			stby_pow_timer = 0;
			x = 0x01;
			for (z = 1; z <= (mach_size-2); z++)
			{
	    		    if (en_head_f & tshirt_f & ATflash_f & x & (~stby_heat_off_f))
			    {
				if ((machine_param.ATflash[z-1].stby_power) == stby_pow_timer) {start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f); stby_heat_off_f |= x;}
			    }
			    x <<= 1;
			}
		    }

		}
	} while (1);
    }
}

void test_print(int head_no)
{

unsigned char z;
unsigned int x;
unsigned short data_read;
unsigned int head_in_pos;
unsigned char time_elapsed;
extern unsigned char print_stage;
extern unsigned char idx_posA;
extern unsigned char lift_up_pos;

    switch (print_stage)
    {
	case 0:	{break;}
	case 1:
	{
	    printf("case1\n");
	    x = 0x01;
	    x <<= (head_no - 1);
    	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(head_no); move_flood_up(head_no);}
    	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posB(head_no);}
	    print_stage = 5;
	    break;
	}

	case 5:
	{
	    printf("case5\n");
	    print_stage = 6;
	    break;
	}

//switch on flash if preheat set
	case 6:
	{
	    printf("case6\n");
/*	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (ATflash_f | RWflash_f) & x)
		{
		    if ((machine_param.ATflash[z-1].preheat_f == 1) | (machine_param.RWflash[z-1].preheat_f == 1)) {start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f + machine_param.RWflash[z-1].socket_f);}
		}
		x <<= 1;
	    }
*/
	    print_stage = 7;
	    break;
	}

//index
	case 7:
	{
	    printf("case7\n");
	    if (lift_up_pos == 1) {move_lift_down_check(IDX_BOARD);}
	    else {break;}

	    print_stage = 10;
	    break;
	}

//move flood down and flood
	case 10:
	{
	    printf("case10\n");
	    x = 0x01;
	    x <<= (head_no - 1);
    	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(head_no); move_flood_down(head_no);}
//	    usleep(flood_delay * 100000);
	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posA(z);}

	    print_stage = 15;
	    break;
	}
//check index and head pos
	case 15:
	{
	    printf("case15\n");
	    if (check_head_pos(head_no)) {print_stage = 20; break;}
	    else {break;}
	}

//lift up
	case 20:
	{
	    printf("case20\n");
	    move_lift_up_check(IDX_BOARD);

	    print_stage = 22;
	    break;
	}

//move index return
	case 22:
	{
	    printf("case22\n");
	    print_stage = 25;
	    break;
	}

//move squeegee down
	case 25:
	{
	    printf("case25\n");
	    x = 0x01;
	    x <<= (head_no - 1);
	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_flood_up(head_no); move_squee_down(head_no);}

//	    usleep(print_delay * 100000);
	    print_stage = 30;
	}

//print
	case 30:
	{
	    printf("case30\n");
	    x = 0x01;
	    x <<= (head_no - 1);
	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posB(head_no);}

	    print_stage = 35;
	    break;
	}

//check heads and index pos
	case 35:
	{
	    printf("case35\n");
	    if (check_head_pos(head_no)) {print_stage = 37; break;}
	    else {break;}
	}

//move squeegee up
	case 37:
	{
	    printf("case37\n");
	    x = 0x01;
	    x <<= (head_no - 1);
	    if (en_head_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(head_no);}

	    print_stage = 40;
	    break;
	}

//dwell
	case 40:
	{
	    printf("case40\n");
	    usleep(machine_param.dwell_time * 100000);

	    print_stage = 45;
	    break;
	}

//flash finish check and lift down
	case 45:
	{
	    printf("case45\n");
	    if (bheat_off == 0) {print_stage = 45; break;}
	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}

	    bheat_off = 0;
	    heat_on_f = 0;
	    test_print_key_f = 0;
	    print_stage = 1;
	    key_test_pressed[head_no] = 0;
	    break;
	}
    }
}


void print_cycle()
{

unsigned int reset;
unsigned char z;
unsigned int x;
unsigned short data_read;
unsigned int head_in_pos;
unsigned char time_elapsed;
extern unsigned char print_stage;
extern unsigned char idx_posA;
extern unsigned char lift_up_pos;
extern unsigned int mach_size;
extern unsigned int en_head_f;
extern unsigned int tshirt_f;
extern unsigned int en_head_fTemp;
extern unsigned int tshirt_fTemp;
extern unsigned int ATflash_f;
extern unsigned int QRflash_f;
extern unsigned int RWflash_f;
extern unsigned int skip_f;
extern unsigned int idx_dir_f;
extern unsigned int totalCount;
extern unsigned int lastCount;

switch (idx_dir_f)
{
/*right direction of rotation*/
case 0:
{
    switch (print_stage)
    {
	case 0:	{break;}
	case 1:
	{
	    printf("case1r\n");
    	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(z); move_flood_up(z);}
		x <<= 1;
	    }
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
//	        if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posB(z);}
		x <<= 1;
	    }
	    print_stage = 5;
	    break;
	}

	case 5:
	{
	    printf("case5r\n");
	    printMsg(_("case5r"));
	    for (z = 1; z <= (mach_size-2); z++) {m_printTemp[z] = machine_param.head[z-1].m_print + 1;}
	    print_stage = 6;
	    break;
	}

//switch on flash if preheat set
	case 6:
	{
	    printMsg(_("case6r"));
	    printf("case6r\n");
/*	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (ATflash_f | RWflash_f) & x)
		{
		    if ((machine_param.ATflash[z-1].preheat_f == 1) | (machine_param.RWflash[z-1].preheat_f == 1)) {start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f + machine_param.RWflash[z-1].socket_f);}
		}
		x <<= 1;
	    }
*/
	    reset = 0x01;
	    tshirt_f <<= 1;
	    reset <<= mach_size-2;
	    tshirt_f &= ~reset;
	    if (!((print_finish_f == 1) || (print_test_f == 1) || (skip_f == 1))) {tshirt_f += 1;}
	    tshirt_fTemp = tshirt_f;
	    en_head_fTemp = en_head_f;
	    ++AT_temp[3];
	    print_stage = 7;
	    break;
	}

//index
	case 7:
	{
	    printf("case7r\n");
	    printMsg(_("case7r"));
//	    if (lift_up_pos == 1) {move_lift_down_check(IDX_BOARD);}
//	    if (lift_up_pos == 0) {move_idx_posB(IDX_BOARD);}
//	    else {break;}

	    print_stage = 10;
	    break;
	}

//move flood down and flood
	case 10:
	{
	    printf("case10r\n");
	    printMsg(_("case10r"));
	    x = 0x01;
	    for (z = 1; z <= (mach_size - 2); z++)
	    {
		printf("%d %d", z, m_printTemp[z]);
		printf("%d %d", z, machine_param.head[z-1].m_print);
	        if ((en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x) && (m_printTemp[z] >= 1)) {move_squee_up(z); usleep(5000); move_flood_down(z); usleep(5000);}
		x <<= 1;
	    }
	    usleep(machine_param.flood_delay * 100000);
	    x = 0x01;
	    for (z = 1; z <= (mach_size - 2); z++)
	    {
		if ((en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x) && (m_printTemp[z] >= 1)) {move_head_posA(z);}
		x <<= 1;
	    }
	    sleep(3);
	    skip_f = 0;
	    print_stage = 20; //15;
	    break;
	}

//check index and head pos
	case 15:
	{
	    printf("case15r\n");
	    printMsg(_("case15r"));
	    head_in_pos = 0x00;
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x)
		    {
			usleep(5000);
    			if (check_head_pos(z)) {head_in_pos |= x;}
		    }
		    x <<= 1;
	    }
	    if ((head_in_pos & (en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f))) != head_in_pos) {print_stage = 15; break;}
	    usleep(1000);
	    if (multiple_ok) {print_stage = 20; break;}
	    else {if (idx_posB_check(IDX_BOARD) == 1) {print_stage = 20; break;} else {print_stage = 15; break;}}
	    
	}

//lift up
	case 20:
	{
	    printf("case20r\n");
	    printMsg(_("case20r"));
	    if ((machine_param.m_lift_down == 0) && (multiple_ok = 1)) {print_stage = 25; break;}
//	    if ((idx_posA == 0) && (idx_posB == 1)) {move_lift_up_check(IDX_BOARD);}
//	    else {break;}

	    print_stage = 22;
	    break;
	}

//move index return
	case 22:
	{
	    printf("case22r\n");
	    printMsg(_("case22"));
//	    if ((lift_up_pos == 1) && (lift_dn_pos == 0)) {move_idx_return(IDX_BOARD);}
//	    else {break;}

	    print_stage = 25;
	    break;
	}

//move squeegee down
	case 25:
	{
	    printf("case25r\n");
	    printMsg(_("case25r"));
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if ((en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x) && (m_printTemp[z] >= 1)) {move_flood_up(z); usleep(5000); move_squee_down(z); usleep(5000);}
		x <<= 1;
	    }
	    usleep(machine_param.print_delay * 100000);
	    print_stage = 37; /*30;*/
	}

//print
	case 30:
	{
	    printf("case30r\n");
	    printMsg(_("case30r"));
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		usleep(1000);
		if ((en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x) && (m_printTemp[z] >= 1)) {move_head_posB(z);}
		x <<= 1;
	    }
	    sleep(3);
	    print_stage = 37; //35;
	    break;
	}

//check heads and index pos
	case 35:
	{
	    printf("case35r\n");
	    printMsg(_("case35r"));
	    head_in_pos = 0x00;
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x)
		    {
			usleep(1000);
    			if (check_head_pos(z)) {head_in_pos |= x;}
		    }
		    x <<= 1;
	    }
	    if ((head_in_pos & (en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f))) != head_in_pos) {break;}
	    usleep(1000);
	    if (idx_posA_check(IDX_BOARD)) {print_stage = 37; break;}
	    else {break;}
	}

//move squeegee up
	case 37:
	{
	    printf("case37r\n");
	    printMsg(_("case37r"));
	    multiple_ok = 0;
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if ((en_head_fTemp & tshirt_fTemp & (~ATflash_f) & (~RWflash_f) & x) && (m_printTemp[z] >= 1)) {usleep(5000); move_squee_up(z);}
		x <<= 1;
		if (m_printTemp[z] > 0) {m_printTemp[z] -= 1; multiple_ok = 1;}
	    }
	    if (multiple_ok) {printMsg(_("m_ok")); print_stage = 45; break;}
	    else {print_stage = 40; multiple_ok = 0; break;}
	}

//dwell
	case 40:
	{
	    printf("case40r\n");
	    printMsg(_("case40r"));
	    usleep(machine_param.dwell_time * 100000);

	    print_stage = 50;
	    break;
	}

//flash finish, move lift down check - only for multiple print
	case 45:
	{
	    printf("case45r\n");
	    printMsg(_("case45r"));
//	    if (bheat_off == 0) {print_stage = 45; break;}
//	    if ((idx_posB == 0) && (idx_posA == 1)) {if (m_lift_down) {move_lift_down_check(IDX_BOARD);} else {print_stage = 10; break;}} else {break;}

	    print_stage = 10;
	    break;
	}

//flash finish, move lift down check
	case 50:
	{
	    printf("case50r\n");
	    printMsg(_("case50r"));
//	    if (bheat_off == 0) {print_stage = 45; break;}
//	    if ((idx_posB == 0) && (idx_posA == 1)) {move_lift_down_check(IDX_BOARD);} else {break;}

	    bheat_off = 0;
	    heat_on_f = 0;
	    totalCount += 1;
	    lastCount += 1;
	    end_cycle = 1;

//	    if (mode_f == 0) {print_stage = 0;} //manual mode
//	    if (mode_f == 1) {print_stage = 7;} //auto mode
	    print_stage = 5;
	    break;
	}

    }
break;
}

/*left direction of rotation*/
case 1:
{
    switch (print_stage)
    {
	case 0:
	{
	    break;
	}

	case 1:
	{
	    printf("case1l\n");
    	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(z); move_flood_up(z);}
		x <<= 1;
	    }

	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posB(z);}
		x <<= 1;
	    }
	    print_stage = 5;
	    break;
	}

//lift up and index return and lift down
	case 5:
	{
	    printf("case5l\n");
	    if (idx_posA == 1) {move_lift_up_check(IDX_BOARD);}
	    if (lift_up_pos == 1) {move_idx_return_check(IDX_BOARD);}
	    else {break;}

	    if ((idx_posB != 1) && (idx_posA != 0)) {break;}
	    else {move_lift_down_check(IDX_BOARD);}

	    print_stage = 6;
	    break;
	}

//switch on flash if preheat set
	case 6:
	{
	    printf("case6l\n");
/*	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (ATflash_f | RWflash_f) & x)
		{
		    if ((machine_param.ATflash[z-1].preheat_f == 1) | (machine_param.RWflash[z-1].preheat_f == 1)) {start_heat(IDX_BOARD, machine_param.ATflash[z-1].socket_f + machine_param.RWflash[z-1].socket_f);}
		}
		x <<= 1;
	    }
*/
	    tshirt_f >>= 1;
	    if (!((print_finish_f == 0) || (print_test_f == 0) || (skip_f == 1))) {tshirt_f += (1<<(machine_size-1));}
	    refreshWheel();

	    print_stage = 7;
	    break;
	}

//index
	case 7:
	{
    	    printf("case8l\n");
	    if (lift_up_pos == 0) {move_idx_posA(IDX_BOARD);}
	    else {break;}

	    print_stage = 10;
	    break;
	}

//move flood down and flood
	case 10:
	{
	    printf("case10l\n");
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
	        if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(z); move_flood_down(z);}
		x <<= 1;
	    }

//	    usleep(flood_delay * 100000);

	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posA(z);}
		x <<= 1;
	    }
	    skip_f = 1;
	    print_stage = 15;
	    break;
	}

//check index return and head pos
	case 15:
	{
	    printf("case15l\n");
	    head_in_pos = 0x00;
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x)
		    {
			usleep(1000);
    			if (check_head_pos(z)) {head_in_pos |= x;}
		    }
		    x <<= 1;
	    }
	    if ((head_in_pos & (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f))) != head_in_pos) {print_stage = 15; break;}

	    if (idx_posA_check(IDX_BOARD) == 1) {print_stage = 20; break;}
	    else {print_stage = 15; break;}
	}

//lift up
	case 20:
	{
	    printf("case20l\n");
	    if ((idx_posB == 0) && (idx_posA == 1)) {move_lift_up_check(IDX_BOARD);}
	    else {break;}

	    print_stage = 22;
	    break;
	}

//move index return
	case 22:
	{
	    printf("case22l\n");
	    if ((lift_up_pos == 1) && (lift_dn_pos == 0)) {move_idx_return(IDX_BOARD);}
	    else {break;}

	    print_stage = 25;
	    break;
	}

//move squeegee down
	case 25:
	{
	    printf("case25l\n");
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_flood_up(z); move_squee_down(z);}
		x <<= 1;
	    }
//	    usleep(print_delay * 100000);
	    print_stage = 30;
	}

//print
	case 30:
	{
	    printf("case30l\n");
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_head_posB(z);}
		x <<= 1;
	    }
	    print_stage = 35;
	    break;
	}

//check heads and index pos
	case 35:
	{
	    printf("case35l\n");
	    head_in_pos = 0x00;
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x)
		    {
			usleep(1000);
    			if (check_head_pos(z)) {head_in_pos |= x;}
		    }
		    x <<= 1;
	    }
	    if ((head_in_pos & (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f))) != head_in_pos) {break;}

	    if (idx_posB_check(IDX_BOARD)) {print_stage = 37; break;}
	    else {break;}
	}

//move squeegee up
	case 37:
	{
	    printf("case37l\n");
	    x = 0x01;
	    for (z = 1; z <= (mach_size-2); z++)
	    {
		if (en_head_f & tshirt_f & (~ATflash_f) & (~RWflash_f) & x) {move_squee_up(z);}
		x <<= 1;
	    }
	    print_stage = 40;
	    break;
	}

//dwell
	case 40:
	{
	    printf("case40l\n");
	    usleep(machine_param.dwell_time * 100000);

	    print_stage = 45;
	    break;
	}

//flash finish check and lift down
	case 45:
	{
	    printf("case45l\n");
//	    if (bheat_off == 0) {print_stage = 45; break;}
	    if ((idx_posB == 1) && (idx_posA == 0)) {move_lift_down_check(IDX_BOARD);} else {break;}

	    bheat_off = 0;
	    heat_on_f = 0;
	    totalCount += 1;
	    lastCount += 1;
	    refreshCounters();
	    end_cycle = 1;

	    if (mode_f == 0) {print_stage = 0;} //manual mode
	    if (mode_f == 1) {print_stage = 7;} //auto mode
	    break;
	}

    }
break;
}
}
}

/* --------------------------------------------------------------------------------------------------- */
/* -------------------------PDO HANDLERS-------------------------------------------------------------- */
/* --------------------------------------------------------------------------------------------------- */

void input_handler(unsigned char input, int head_no)
{
    char main_message[20];
    unsigned long safety_nr;

    if (head_no > 0)
    {
	if (input & bSafetyBar)
	{
	    machine_stop;
	    sprintf(main_message, "Safety bar open on the head %d", head_no);
	    printState(_(main_message));
	    safety_nr = 0x01;
	    safety_nr <<= (head_no-1);
	    safety_stat |= safety_nr;
	}
    }
}

void statusword_handler(unsigned short ICUstatus, int head_no)
{
    unsigned long head_pos_reached;

    if (ICUstatus & ICU_STAT_MOVE_DONE)
    {
//	head_pos_reached = 0x01;
//	head_pos_reached <<= (head_no-1);
//	head_in_pos |= head_pos_reached;
    }
}

void key_handler(unsigned int key_status, int head_no)
{
    unsigned int head_jog_f_temp;

    switch (key_status)
    {
	case PRINT_VEL_UP:
	    {
		if (machine_param.head[head_no-1].print_vel < kmax_print_vel)
		{
		    machine_param.head[head_no-1].print_vel++;
		}
		break;
	    }
	case PRINT_VEL_DN:
	    {
		if (machine_param.head[head_no-1].print_vel > kmin_print_vel)
		{
		    machine_param.head[head_no-1].print_vel--;
		}
		break;
	    }
	case FLOOD_VEL_UP:
	    {
		if (machine_param.head[head_no-1].flood_vel < kmax_flood_vel)
		{
		    machine_param.head[head_no-1].flood_vel++;
		}
		break;
	    }
	case FLOOD_VEL_DN:
	    {
		if (machine_param.head[head_no-1].flood_vel > kmin_flood_vel)
		{
		    machine_param.head[head_no-1].flood_vel--;
		}
		break;
	    }
	case POS_FR_UP:
	    {
		if ((machine_param.head[head_no-1].front_pos < kmax_front_pos) && (machine_param.head[head_no-1].front_pos < machine_param.head[head_no-1].rear_pos))
		{
		    machine_param.head[head_no-1].front_pos++;
		}
		break;
	    }
	case POS_FR_DN:
	    {
		if (machine_param.head[head_no-1].front_pos > kmin_front_pos)
		{
		    machine_param.head[head_no-1].front_pos--;
		}
		break;
	    }
	case POS_RR_UP:
	    {
		if (machine_param.head[head_no-1].rear_pos < kmax_rear_pos)
		{
		    machine_param.head[head_no-1].rear_pos++;
		}
		break;
	    }
	case POS_RR_DN:
	    {
		if ((machine_param.head[head_no-1].rear_pos > kmin_rear_pos) && (machine_param.head[head_no-1].rear_pos > machine_param.head[head_no-1].front_pos))
		{
		    machine_param.head[head_no-1].rear_pos--;
		}
		break;
	    }
	case JOG_UP:
	    {
		key_jogup_pressed[head_no-1] = 1;
		break;
	    }
	case JOG_DN:
	    {
		key_jogdn_pressed[head_no-1] = 1;
		break;
	    }
	case AIR_LEFT:
	    {
		key_airll_pressed[head_no-1] = 1;
		break;
	    }
	case AIR_RIGHT:
	    {
		key_airlr_pressed[head_no-1] = 1;
		break;
	    }
	case KEY_SET:
	    {
		key_set_pressed[head_no-1] ^= 0x01;
		break;
	    }
	case KEY_TEST:
	    {
		key_test_pressed[head_no-1] = 1;
		break;
	    }
	case KEY_STOP:
	    {
		work_f = 0;
		break;
	    }
	case KEY_IDX:
	    {
		key_index_pressed[head_no-1] = 1;
		break;
	    }
	case KEY_TABLE:
	    {
		key_table_pressed = 1;
		break;
	    }
	case KEY_SQ_FL:
	    {
		key_squ_fl_pressed[head_no-1] = 1;
		break;
	    }
	case NO_KEY:
	    {
		break;
	    }
    }
}



/* --------------------------------------------------------------------------------------------------- */
/* ---------------------  START CAN OPEN PROCEDURES  ------------------------------------------------- */
/* --------------------------------------------------------------------------------------------------- */

unsigned short check_ICU_status(int head_no)
{
    unsigned short index;
    char subindex;

    index = 0x6041;
    subindex = 0x00;
    ReadDictionaryEntry(0, head_no, index, subindex, (char *) &data);
    return((unsigned short)data);
}

void change_POS(int head_no, int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x607A;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_VEL(int head_no, unsigned int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6081;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_ACC(int head_no, unsigned int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6083;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_DACC(int head_no, unsigned int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6084;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_H_OFF(int head_no, int param_val)
		    {
    unsigned short index;
    char subindex;

    index = 0x607C;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_H_VEL(int head_no, unsigned int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6099;
    subindex = 0x01;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_H_ACC(int head_no, unsigned int param_val)
{
    unsigned short index;
    char subindex;

    index = 0x609A;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_CTRL(int head_no, unsigned short param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6040;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_MODE(int head_no, char param_val)
{
    unsigned short index;
    char subindex;

    index = 0x6060;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void change_OUT(int head_no, unsigned int param_val)	//bit16 - OUT1, ... , bit23 - OUT8
{
    unsigned short index;
    char subindex;

    index = 0x60FE;
    subindex = 0x01;
    WriteDictionaryEntry(0, head_no, index, subindex, sizeof(param_val), &param_val);
}

void write_STRING(int head_no, char data[])
{
    unsigned short index;
    char subindex;

    index = 0x0000;
    subindex = 0x00;
    WriteDictionaryEntry(0, head_no, index, subindex, strlen(data), &data);
}

unsigned int read_OUT(int head_no)
{
    unsigned short index;
    char subindex;
    
    index = 0x60FE;
    subindex = 0x01;
    ReadDictionaryEntry(0, head_no, index, subindex, (char *) &data);
    return((unsigned int)data);
}

unsigned short read_analog(int head_no)
{
    unsigned short index;
    char subindex;

    index = 0x2000;
    subindex = 0x00;
    ReadDictionaryEntry(0, head_no, index, subindex, (char *) &data);
    return((unsigned short)data);
}

unsigned int read_INP(int head_no)	//bit16 - INP1, ... , bit21 - INP6
{
    unsigned short index;
    char subindex;

    index = 0x60FD;
    subindex = 0x00;
    ReadDictionaryEntry(0, head_no, index, subindex, (char *) &data);
    return((unsigned int)data);
}

/* ----------------------------------------------------------------------------------------------------------------- */
/* ---------------------------- END CAN OPEN PROCEDURES ------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------------- */






