#include <gnome.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

unsigned int login_user;
unsigned int mach_size;
unsigned int en_head_f;
unsigned int tshirt_f;
unsigned int en_head_fTemp;
unsigned int tshirt_fTemp;
/* unsigned int QRflash_f; */
unsigned int ATflash_f;
unsigned int RWflash_f;
unsigned int AT_temp[20];
unsigned int work_f;
unsigned int skip_f;
unsigned int mode_f;// mode_fTmp;
unsigned int home_f;
unsigned int wheel_f;
unsigned int idx_en_f;
unsigned int idx_dir_f;
unsigned int lift_en_f;
unsigned int lastCount, totalCount;
unsigned int print_finish_f;
unsigned int print_test_f;
unsigned char print_stage;
unsigned int heat_off_f;
unsigned int stby_heat_off_f;
unsigned char end_cycle;
unsigned char test_print_key_f; //jezeli rowne 1, to znaczy ze nacisniety zostal przycisk na glowicy TEST PRINT i wykonywana jest procedura test_print
unsigned char multiple_ok;

unsigned char heat_on_f;
unsigned char bheat_off;
unsigned char half_idx_f;
unsigned char h_idx_stage;
unsigned char reset_f;
unsigned char head_jog_f[22];	//zmiena rowna 1, jezeli glowica jest w jog ("1" na odpowiednim miejscu)
unsigned int outputs[22];
unsigned char m_printTemp[22];
unsigned int data;
unsigned int status;
char data_read[24];
unsigned char idx_homing;
unsigned char lift_homing;
unsigned int safety_stat;	//zmienna informuje, ktore z safety sa otwarte ("1" na odpowiednim miejscu)
unsigned int head_in_pos;	//zmienna informuje, ktore z glowic dojechaly juz na miesce przy PTP

//stale uzywane przy zmianie parametrow maszyny z keypad na glowicy
#define kmax_front_pos 3500
#define kmin_front_pos 0
#define kmax_rear_pos 3500
#define kmin_rear_pos 0
#define kmax_print_vel 50
#define kmin_print_vel 0
#define kmax_flood_vel 50
#define kmin_flood_vel 0

unsigned char lift_up_pos;	//zmienna rowna 1, jezeli lift jest w gorze
unsigned char lift_dn_pos;
unsigned char idx_posA;		//zmienna rowna 1, jezeli indexer jest w pozycji A
unsigned char idx_posB;
unsigned char PDO_data[22][8];

struct head_param
{
	unsigned int print_vel;
	unsigned int flood_vel;
	unsigned int front_pos;
	unsigned int rear_pos;
	unsigned int home_offset;
	unsigned int home_vel;
	unsigned int jog_vel;
	unsigned int m_print;	
};

struct idx_param
{
	unsigned int home_offset;
	unsigned int home_vel;
	unsigned int home_acc;
	unsigned int vel;
	unsigned int acc;
	unsigned int dist;
	unsigned int ret_vel;
	unsigned int ret_acc;
	unsigned int half_vel;
	unsigned int half_acc;
};

struct lift_param
{
	unsigned int home_offset;
	unsigned int home_vel;
	unsigned int home_acc;
	unsigned int vel;
	unsigned int acc;
	unsigned int dist;
	unsigned int half_vel;
	unsigned int half_acc;
};

struct ATflash_param
{
	unsigned int cure_time;
	unsigned int temp;
	unsigned int stby_time;
	unsigned int stby_power;
	unsigned int warm_up_time;
	unsigned int sensor_type;
	unsigned int preheat_f;
	unsigned int socket_f;
};

/* struct QRflash_param
{
	unsigned int scan_dist;
	unsigned int scan_vel;
	unsigned int appr_dist;
	unsigned int appr_vel;
	unsigned int nr_of_scans;
	unsigned int preheat_f;
}; */

struct RWflash_param
{
/* 	unsigned int preheat_time; */
	unsigned int cure_time;
/* 	unsigned int preheat_f; */
	unsigned int socket_f;
};
 
struct vind_param
{
	struct head_param head[20];
 	struct ATflash_param ATflash[20];
/* 	struct QRflash_param QRflash[20]; */
	struct RWflash_param RWflash[20];
	struct idx_param idx;
	struct lift_param lift;
	unsigned int dwell_time;
	unsigned int off_contact;
	unsigned int m_lift_down;		
	unsigned int flood_delay;
	unsigned int print_delay;
	unsigned int mach_size;	
} machine_param, machine_paramTmp;


GtkWidget *mainWindow, *setupWindow, *logWindow, *selHeadWindow, *loginWindow, *jobWindow; *paramLabel[50];

/*
show_hide_f => b31, ..., b5, b4, b3, b2, b1, b0  (4Byte)

b0	=> 0 or 1	- 0 hide Ctrl Panel
b1	=> 0 or 1	- 0 hide Status
b2	=> 0 or 1	- 0 hide Counters
b3	=> 0 or 1	- 1 hide Total Counter
...

*/
unsigned int show_hide_f, refreshLevel_f;

char logBegin, allHeads, autorizationLevel, fileName;
int logValue, loginValue, setupHeadNr, flashSocNr; 

enum
{
first,
/*******	HEAD PARAMETERS			*******/
head_print_vel, head_flood_vel, head_front_pos, head_rear_pos,
head_home_offset, head_home_vel,head_m_print, head_jog_vel, 
/*******	FLASH PARAMETERS		*******/
flash_AT_cure_time, flash_AT_temp, flash_AT_stby_time, flash_AT_stby_power, flash_AT_warm_up_time, 
/* flash_QR_scan_dist, flash_QR_scan_vel, flash_QR_appr_dist, flash_QR_appr_vel, flash_QR_nr_of_scans, */
/* flash_RW_preheat_time, */ flash_RW_cure_time,
/*******	INDEX PARAMETERS		*******/
index_home_offset, index_home_vel, index_home_acc, index_vel, index_acc, index_dist, index_ret_vel,
index_ret_acc, index_half_vel, index_half_acc,
/*******	LIFT PARAMETERS		*******/
lift_home_offset, lift_home_vel, lift_home_acc, lift_vel, lift_acc, lift_dist,
/*******	OTHERS PARAMETERS		*******/
dwell_time, off_contact, head_flood_delay, head_print_delay, machine_size,

last
} paramNr;

enum
{
FIRST,
HIDE_COUNTERS, RESET_COUNTER, TABLE_UP_DOWN, TEST_PRINT, RESET, HOME, PANEL_ON_OFF, HIDE_STATUS, 
DWELL_UP, DWELL_DOWN, MODE, M_LIFT_DOWN,
/*******	HEAD BUTTONS			*******/
HEAD_ENABLE_DISABLE, HEAD_TEST_PRINT, HEAD_HOME, 
/*******	FLASH BUTTONS			*******/
AT_FLASH_SET_REMOVE, RW_FLASH_SET_REMOVE, FLASH_AT_SENSOR_TYPE, FLASH_AT_SOCKET_NR, FLASH_RW_SOCKET_NR, 
FLASH_AT_PREHEAT_F,  
/* FLASH_RW_PREHEAT_ON_OFF,  */
/* QR_FLASH_SET_REMOVE, FLASH_QR_HOME, FLASH_QR_PREHEAT_ON_OFF,  */
/*******	INDEX BUTTONS			*******/
INDEX_ENABLE_DISABLE, INDEX_CHANGE_DIRECTION, HALF_INDEX_RIGHT, HALF_INDEX_LEFT, INDEX_HOME, INDEX_RIGHT, 
INDEX_LEFT, 
/*******	LIFT BUTTONS			*******/
LIFT_ENABLE_DISABLE,  LIFT_HOME, LIFT_UP, LIFT_DOWN, 
/*******	SAVE RECALL BUTTONS		*******/
SAVE_JOB, EDIT_JOB, RECALL_JOB,
LAST
} buttonNr;

typedef struct {
int prec;
char aut_level;
char name[30];
char descr[150];
char unit[5];
int max;
int min;
int step;
int def;
unsigned int *value;
} param;
param parameter;

struct {
	char fileName[30];
	char fileDescr[255];
} files[10];

void printState(char state[50]);
void printMsg(char msg[150]);
void refreshCounters();
void refreshWheel();
gboolean start_stop (void);
void refreshStartStop();
void on_startStopBox_button_press_event     (GtkWidget *widget, GdkEventButton  *event, gpointer data);
gboolean on_skipBox_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data);
gboolean on_printfBox_button_press_event (GtkWidget *widget, GdkEventButton  *event, gpointer user_data);
void panelButtonPressed (GtkButton *widget, int user_data);
void controlButtonPressed (GtkButton *button,int buttonNr);
void paramData (struct vind_param *param);


void *machine_loop();
void set_ICU_preoperational_mode(int head_no);
void set_ICU_operational_mode(int head_no);
void move_lift_down_check(int head_no);
unsigned char lift_down_check(int head_no);
void move_lift_down(int head_no);
void move_lift_up_check(int head_no);
unsigned char lift_up_check(int head_no);
void move_lift_up(int head_no);
void move_idx_lock(void);
void move_idx_unlock(void);
void move_idx_posA_check(int head_no);  //move to position near home position with pos checking
unsigned char idx_posA_check(int head_no);
void move_idx_posA(int head_no);  //move to position near home position
void move_idx_posB_check(int head_no);  //move to postion away from home position with pos checkig
unsigned char idx_posB_check(int head_no);
void move_idx_posB(int head_no);  //move to postion away from home position
void move_idx_posAB(int head_no);  //move to medium position (HALF INDEX)
void move_idx_return_check(int head_no);
void move_idx_return(int head_no);

void move_idx_right(int head_no);
void move_idx_left(int head_no);
void move_hidx_right(int head_no);
void move_hidx_left(int head_no);
void move_idx_rotate(int head_no);
void move_table(int head_no);

void move_head_posA(int head_no);  //move to outside position (front position) without pos checking
void move_head_posB(int head_no);  //move to inside position (rear position) without pos checking
unsigned char check_head_pos(int head_no);
void enable_head(int head_no);
void disable_head(int head_no);
void move_slock_left(int head_no);  //move left screen lock up & down
void move_slock_right(int head_no);  //move right screen lock up & down
void jog_head_up(int head_no);
void jog_head_down(int head_no);
void move_flood_down(int head_no);
void move_flood_up(int head_no);
void move_squee_down(int head_no);
void move_squee_up(int head_no);
void move_squ_fl(int head_no);
void buzzer_on(unsigned long buzz_time);
void switch_LED(unsigned char state, int head_no);
void machine_error();
void machine_stop();
void head_home(int head_no);
unsigned char check_head_home(int head_no);
void lift_home(int head_no);
void idx_home(int head_no);
void start_heat(int head_no, int output);
void stop_heat(int head_no, int output);
unsigned short read_temp(int head_no);
void *heat_function();
void print_cycle();

void input_handler(unsigned char input, int head_no);
void statusword_handler(unsigned short ICUstatus, int head_no);
void key_handler(unsigned int key_status, int head_no);




/* --------------------------------------------------------------------------------------------------- */
/* ---------------------  START CAN OPEN PROCEDURES  ------------------------------------------------- */
/* --------------------------------------------------------------------------------------------------- */

unsigned short check_ICU_status(int head_no);
void change_POS(int head_no, int param_val);
void change_VEL(int head_no, unsigned int param_val);
void change_ACC(int head_no, unsigned int param_val);
void change_DACC(int head_no, unsigned int param_val);
void change_H_OFF(int head_no, int param_val);
void change_H_VEL(int head_no, unsigned int param_val);
void change_H_ACC(int head_no, unsigned int param_val);
void change_CTRL(int head_no, unsigned short param_val);
void change_MODE(int head_no, char param_val);
void change_OUT(int head_no, unsigned int param_val);	//bit16 - OUT1, ... , bit23 - OUT8
void write_STRING(int head_no, char data[]);
unsigned int read_OUT(int head_no);
unsigned short read_analog(int head_no);
unsigned int read_INP(int head_no);	//bit16 - INP1, ... , bit21 - INP6
