/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "callbacks.h"
#include "Can.h"
#include "CanOpenMatic.h"
#include "CanOpener.h"
#include "Can4Open.h"

#include "file_man.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <asm/types.h>
#include <unistd.h>
#include <curses.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

void message_handler(Message *m);
extern void *machine_loop();
//void *heat_function();
void *refreshScreen();

int busfd;

int
main (int argc, char *argv[])
{
char txt[30];
pthread_t a_thread, b_thread;
int res1, res2;
extern logfunc rxloggingfunc,txloggingfunc;
extern int wait;

//Message message; uncomment if messages are to be diplayed
rxloggingfunc = message_handler;
txloggingfunc = message_handler;

//wait = 1;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gnome_init ("vin", VERSION, argc, argv);

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  
  
  gtk_rc_parse( "pix/gtkrc" );

  mainWindow = create_mainWindow ();
  gtk_widget_set_name( mainWindow, "main" );
  gtk_widget_show (mainWindow);

		
  	if (openParams  (&machine_param, "par/default.par")) printMsg (_("\n>defaults restored"));
	else  
	{	
		printMsg (_("\n>defaults restore failed"));
	  	if (openParams  (&machine_param, "backup/default.par")) printMsg (_("\n>backup restored"));
		else 
		{
			printMsg (_("\n backup restore failed"));
			printMsg (_("\n>ALL PARAMETERS LOST !!!"));
		  	if (openParams  (&machine_param, "backup/.lastSafe/default.par")) printMsg (_("\n>\"last safe\" restored"));
			else
			{
				printMsg (_("\n MACHINE WILL NOT WORK\n PROPERLY"));
				machine_param.mach_size=0;
			}
			printState(_("STOP! contact SERVICE!"));
		}
	}
  	mach_size = machine_param.mach_size+6; // !!! necessary
	

	if ((show_hide_f & 0x01) == 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));
	else  {
	paramNr = dwell_time;
	paramData(&machine_param);
	paramValuePrint(&txt);
	gtk_label_set_text (lookup_widget (GTK_WIDGET(mainWindow),"dwellTimeLabel"), txt);
	gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"ctrlPanel"));	
	}
	
	if ((show_hide_f & 0x02) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
	else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"statusFrame"));
		
	if ((show_hide_f & 0x04) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));
	else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"countersFrame"));

	if ((show_hide_f & 0x08) != 0)	gtk_widget_hide (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));
	else  gtk_widget_show (lookup_widget(GTK_WIDGET(mainWindow),"totalCountLabel"));

	res1 = pthread_create(&a_thread, NULL, machine_loop, NULL);
	if (res1 != 0)
	{
	    printf("Thread main_loop creation failed");
	    exit(EXIT_FAILURE);
	}
	res2 = pthread_create(&b_thread, NULL, refreshScreen, NULL);
	if (res2 != 0)
	{
	    printf("Thread heat_function creation failed");
	    exit(EXIT_FAILURE);
	}


/*	res2 = pthread_create(&b_thread, NULL, heat_function, NULL);
	if (res2 != 0)
	{
	    printf("Thread heat_function creation failed");
	    exit(EXIT_FAILURE);
	}
*/
//	f_can_callback(message_handler);

	if ((busfd = f_can_open("/dev/can1")) <= 0)
	{
		printMsg(_(">Unable to open CAN device\n"));
	}


	head2soc(0); //initialize flash socket setup
		
	makeWheel(-1);

	refreshCounters();

	refreshWheel();
	
	refreshStatus();
//	main_loop();
//	print_stage = 5;
	idx_dir_f = 0;
	end_cycle = 1;

  gtk_main ();
//  f_can_close(busfd);
  return 0;
}

void message_handler(Message *m)
{
//  char my_string[] = "PDO1tx";
  unsigned char inp_stat;
  unsigned short word_stat;
  int key_stat;
  int i;
  extern proceed_info proceed_infos[];

    int fc = GET_FUNCTION_CODE((*m));
    int ID = GET_NODE_ID((*m));
    printf("%-6.6s %2.2x %s",
	      proceed_infos[fc].name,
	      ID,
	      m->rtr ? "Yes" : "No ");
    for ( i = 0; i < m->len;i++)
    {
      printf("%2.2x ",m->data[i]);
    }
    printf("\n");
//	printMsg(_("PDO"));

//obsluga PDO

    if (proceed_infos[fc].name[0] == 'P')
    {
//	printState(_("PDO1"));
//	if (m->data[3] == 0x08) printState(_("data received"));

//INPUTS
//	inp_stat = m->data[7];
//	input_handler(inp_stat, ID);

//STATUSWORD
/*	if ((PDO_data[ID][0] != m->data[0]) || (PDO_data[ID][1] != m->data[1]));
	{
	    word_stat = 0;
	    word_stat += m->data[0];
	    word_stat <<= 8;
	    word_stat += m->data[1];
	    statusword_handler(word_stat, ID);
	}
*/
//KEYBOARD - VINDICATOR
	if ((PDO_data[ID][3] != m->data[3]) || (PDO_data[ID][4] != m->data[4]) || (PDO_data[ID][5] != m->data[5]) || (PDO_data[ID][6] != m->data[6]));
	{
	    key_stat = 0;
	    for (i = 3; i < 7; i++)
	    {
		key_stat += m->data[i];
		if (i < 6) {key_stat <<= 8;}
	    }
	    key_handler(key_stat, ID);
	}
//KEYBOARD - TRIDENT
/*
	if ((PDO_data[ID][2] != m->data[2]) || (PDO_data[ID][3] != m->data[3]) || (PDO_data[ID][4] != m->data[4]) || (PDO_data[ID][5] != m->data[5]));
	key_stat = 0;
	for (i = 2; i < 6; i++)
	{
	    key_stat += m->data[i];
	    if (i < 5) {key_stat <<= 8;}
	}
*/
        for ( i = 0; i < m->len;i++)
	{
    	    PDO_data[ID][i] = m->data[i];
	}

    }

}
/*
void *main_loop(void *nothin)
{
//    struct shared_use_st {
//        int busfd;
//    };
    extern unsigned int work_f;
    extern unsigned char reset_f;
    extern unsigned char print_stage;
    unsigned char z;
    unsigned short data = 0x00;
//    void *shared_memory = (void *)0;
//    struct shared_use_st *shared_stuff;
//    int shmid;

/*    shmid = shmget ((key_t)1234, sizeof(struct shared_use_st), 0666 | IPC_CREAT);
    if (shmid == -1)
    {
	fprintf(stderr, "shmget failed\n");
	exit(EXIT_FAILURE);
    }
    shared_memory = shmat(shmid, (void *)0, 0);
    if (shared_memory == (void *)-1)
    {
	fprintf(stderr, "shmat failed\n");
	exit(EXIT_FAILURE);
    }
    shared_stuff = (struct shared_use_st *)shared_memory;
*/
//    if (busfd = f_can_open("/dev/can1") <= 0) {printState(_("Unable to open CAN"));}
//    do
//    {
//	if ((work_f==0) && (reset_f==1))
//	{
/*	    for (z = 0; z <= (mach_size-2); z++)
	    {
		if (key_jogup_pressed[z]) {jog_head_up(z+1);}
		if (key_jogdn_pressed[z]) {jog_head_down(z+1);}
		if (key_airll_pressed[z]) {move_slock_left(z+1); key_airll_pressed[z]=0;}
		if (key_airlr_pressed[z]) {move_slock_right(z+1); key_airlr_pressed[z]=0;}
		if (key_squ_fl_pressed[z]) {move_squ_fl(z+1); key_squ_fl_pressed[z]=0;}
		if (key_index_pressed[z]) {move_idx_rotate(IDX_BOARD); key_index_pressed[z]=0;}
		if (key_table_pressed) {move_table(IDX_BOARD); key_table_pressed=0;}
		if ((key_test_pressed[z] == 1) && (test_print_key_f == 0)) {test_print_key_f = 1; test_print(z);}
	    }
*///	}
//	if (((work_f==1)))// || (end_cycle==0)) && (reset_f==1))
//	{
/*	    end_cycle = 0;
	    if ((mode_f == 0) && (print_stage == 0)) {print_stage = 7;}
	    if (((print_finish_f == 1) || (print_test_f == 1)) && (tshirt_f == 0))
	    {
		work_f = 0;
		print_finish_f = 0;
		print_test_f = 0;
		skip_f = 1;
	    }
	    else {print_cycle();}
*/
//	    WriteDictionaryEntry(0, 0x01, 0x6040, 0x00, 0x02, &data);
//	    usleep(1000);
//	    WriteDictionaryEntry(0, 0x02, 0x6040, 0x00, 0x02, &data);
//	    usleep(1000);
//	    WriteDictionaryEntry(0, 0x03, 0x6040, 0x00, 0x02, &data);
//	    usleep(1000);
//    	    print_cycle();
//	}
//
//	usleep(1000);
//    } while (1);
//}

void *refreshScreen()
{
    extern unsigned int tshirt_f;
    extern unsigned int totalCount;
    extern unsigned int lastCount;
    
    sleep(4);
    tshirt_f = 0xFFFF;
    refreshWheel();
    usleep(1000000);
    tshirt_f = 0x0000;
    refreshWheel();
    usleep(500000);
do
{
    usleep(300000);
//    jakas_zmienna = tshirt_f;
//    tshirt_f += 1;
    refreshWheel();
    refreshCounters();
}while(1);
}