/*
ODedit

Nathan Z. Gustavson
ngustavson@emacinc.com
Emac.inc
www.emacinc.com

1/27/03 

Description:
A small C program using the canopen libraries 
to read/write the OL of CANOPEN device

ex:
using an AMC device object;

ODedit r can0 01 0x1000
>20192

ODedit w can0 01 0x100B 4
>data written
*/

#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#include <string.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <asm/types.h>
#include <unistd.h>
#include <curses.h>

#include "Can.h"
#include "CanOpenMatic.h"
#include "CanOpener.h"
#include "Can4Open.h"


#define MAXPACKETS 20

void printpacket(Message *m, int state);

void *machine_loop();

struct packet {
Message message;
int state;
}packets[MAXPACKETS];

int packetnum = 0;



static void storepacket(Message *m, int state)
{
if(packetnum>MAXPACKETS)
return;

memcpy(&packets[packetnum].message,m,sizeof(Message));
packets[packetnum].state = state;

++packetnum;
}




int busfd;

int main()
{
pthread_t a_thread, b_thread;
int res1, res2;
char rw;
char can_device[40];
extern logfunc rxloggingfunc,txloggingfunc;
extern int wait;
int i;

//wait = 1;
//rxloggingfunc = printpacket;
//txloggingfunc = printpacket;

//This can no longer be done in the low latency system.
//callbacks must not create large latencies,as they execute directly
//from the signal request and will block incoming packets.




rxloggingfunc = storepacket;
txloggingfunc = storepacket;


   if((busfd = f_can_open("/dev/can1"))<=0)
     {
       printf("couldn't open can1");
       return 0;
     }

   /*
    res1 = pthread_create(&a_thread, NULL, machine_loop, NULL);
	if (res1 != 0)
	{
	    printf("Thread main_loop creation failed");
	    exit(EXIT_FAILURE);
	}
    sleep(5);

    */
   machine_loop();
   sleep(5);

    f_can_close(busfd);

printf("stored %u packets\n",packetnum);

for(i=0;i<packetnum;i++)
printpacket(&packets[i].message,packets[i].state);

return 0;
}

void *machine_loop()
{
int index;
int z;

    for (z=1; z<=2; z++)
    {
	WriteDictionaryEntry(0, 0x02, 0x6040, 0, 0x02, &index);
//	usleep(10000);
	ReadDictionaryEntry(0, 0x02, 0x6040, 0, &index);
//	usleep(100000);
	WriteDictionaryEntry(0, 0x01, 0x6040, 0, 0x02, &index);
//	usleep(10000);
        ReadDictionaryEntry(0, 0x01, 0x6040, 0, &index);
	printf("Number of iteration: %d\n", z);
    }

    printf("data written\n");
    return(0);
}

void printpacket(Message *m, int state)
{
  int i;
  extern proceed_info proceed_infos[];
  if(state>=0){
    int fc = GET_FUNCTION_CODE((*m));
    int ID = GET_NODE_ID((*m));
    printf("%s%-6.6s %2.2x %s",
	      state == STATE_Tx ? ">" : "<",
	      proceed_infos[fc].name,
	      ID,
	      m->rtr ? "Yes" : "No ");
    for ( i = 0; i < m->len;i++){
      printf("%2.2x ",m->data[i]);
    }
      printf("\n");
  } else {
    printf("Read Error (%d)",state);
  }
  
  
}









