
/*   Transmit sends a bunch of telegrams by filling them with       */
/*   different CANids and data bytes. You may send more than one    */
/*   telegram with write just by sending out an array of telegrams. */
 
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <can4linux.h>

#define LOOPMESS "LOOP"
#define PACKETNUM 100


int main(int argc,char **argv)
{
int fd,fdrx;
int i,sent;
canmsg_t tx[PACKETNUM];
char device[40] = "/dev/can0";
char devicerx[40] = "/dev/can1";
 
    printf("transmitting over CAN device %s\n", device);
    
    if(( fd = open(device, O_RDWR )) < 0 ) {
	fprintf(stderr,"Error opening CAN device %s\n", device);
        exit(1);
    }

 
 
if(( fdrx = open(devicerx, O_RDWR )) < 0 ) {
	fprintf(stderr,"Error opening CAN device %s\n", device);
        exit(1);
    }


for(i=0;i<PACKETNUM;i++)
  {
      sprintf(tx[i].data,LOOPMESS);
      //printf("sending '%s'\n",tx[i].data );
      tx[i].flags = 0;  
      tx[i].length = strlen(tx[0].data);  
      tx[i].id=500;

  
    sent=write(fd, &tx[i], 1);// sleep(1);
    if(sent <= 0) {
	printf("transmitter not ready");
    }
  }    

sleep(1);    


printf("receiving over CAN device %s\n", devicerx);

for(i=0;i<PACKETNUM;i++)
  {
 sent = read(fdrx,&tx[i],1);

 if(sent <= 0) {
	printf("loopback test failed, %x chars received\n",sent);
	close(fd);
	close(fdrx);
	return 0;
    }

 if(strcmp(tx[i].data,LOOPMESS))
   {
   printf("loopback test failed, %s returned\n",tx[0].data);
   close(fd);
   close(fdrx);
   return 0;
   }
  }

printf("%s - > %s passed \n",device, devicerx);
sleep(1);

printf("transmitting over CAN device %s\n", devicerx);
for(i=0;i<PACKETNUM;i++)
  {
      //printf("sending '%s'\n",tx[0].data );
      sent=write(fdrx, &tx[i], 1); //sleep(1);

    if(sent <= 0) {
	printf("transmitter not ready");
    }

  }
sleep(1);

printf("receiving over CAN device %s\n", device);

for(i=0;i<PACKETNUM;i++)
  {
 sent = read(fd,&tx[i],1);

 if(sent <= 0) {
	printf("loopback test failed, %x chars received\n",sent);
	close(fd);
	close(fdrx);
	return 0;
    }

 if(strcmp(tx[i].data,LOOPMESS))
   {
   printf("loopback test failed, %s returned\n",tx[i].data);
   close(fd);
   close(fdrx);
   return 0;
   }
  }


   printf("\n%s received both ways, loopback test passed\n",tx[0].data);

 close(fd);
 close(fdrx); 

    return 0;
}

